// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014 -2019, Will Godfrey

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code.


// generated by Fast Light User Interface Designer (fluid) version 1.0305

#include "ConfigUI.h"
#include "Misc/SynthEngine.h"
#include "Misc/Bank.h"
#include "MasterUI.h"
#include "Misc/FileMgrFuncs.h"
#include "Misc/TextMsgBuffer.h"

    namespace { // Implementation details...
        TextMsgBuffer& textMsgBuffer = TextMsgBuffer::instance();
    }
extern SynthEngine *firstSynth;

void ConfigUI::cb_configwindow_i(Fl_Double_Window* o, void*) {
  o->hide();
}
void ConfigUI::cb_configwindow(Fl_Double_Window* o, void* v) {
  ((ConfigUI*)(o->user_data()))->cb_configwindow_i(o,v);
}

void ConfigUI::cb_osc_size_i(Fl_Choice* o, void*) {
  //
                        send_data(0, CONFIG::control::oscillatorSize, 256 << o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_osc_size(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_osc_size_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_osc_size[] = {
 {"256", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"512", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"1024", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"2048", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"4096", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"8192", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"16384", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_buff_size_i(Fl_Choice* o, void*) {
  //
                        send_data(0, CONFIG::control::bufferSize, 16 << o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_buff_size(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_buff_size_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_buff_size[] = {
 {"16", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"32", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"64", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"128", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"256", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"512", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"1024", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"2048", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"4096", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"8192", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_pad_interpol_i(Fl_Choice* o, void*) {
  //
                        send_data(0, CONFIG::control::padSynthInterpolation, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_pad_interpol(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_pad_interpol_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_pad_interpol[] = {
 {"Linear(fast)", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Cubic(slow)", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_v_keyboard_i(Fl_Choice* o, void*) {
  //
                        send_data(0, CONFIG::control::virtualKeyboardLayout, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_v_keyboard(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_v_keyboard_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_v_keyboard[] = {
 {"QWERTY", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"Dvorak", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"QWERTZ", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"AZERTY", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_compression_i(Fl_Counter* o, void*) {
  //
                        send_data(0, CONFIG::control::XMLcompressionLevel, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_compression(Fl_Counter* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_compression_i(o,v);
}

void ConfigUI::cb_reports_i(Fl_Choice* o, void*) {
  //
                        send_data(TOPLEVEL::action::forceUpdate, CONFIG::control::reportsDestination, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_reports(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_reports_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_reports[] = {
 {"stdout", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"Console Window", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_instrument_i(Fl_Choice* o, void*) {
  //
                        send_data(0, CONFIG::control::savedInstrumentFormat, o->value() + 1, TOPLEVEL::type::Integer);
}
void ConfigUI::cb_instrument(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_instrument_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_instrument[] = {
 {"Legacy (.xiz)", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"Yoshimi (.xiy)", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"Both (.xiz + .xiy)", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_setDefaultState_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::defaultStateStart, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_setDefaultState(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_setDefaultState_i(o,v);
}

void ConfigUI::cb_nonFatal_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::hideNonFatalErrors, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_nonFatal(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_nonFatal_i(o,v);
}

void ConfigUI::cb_showSplash_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::showSplash, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_showSplash(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_showSplash_i(o,v);
}

void ConfigUI::cb_logTimes_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::logInstrumentLoadTimes, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_logTimes(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_logTimes_i(o,v);
}

void ConfigUI::cb_logXML_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::logXMLheaders, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_logXML(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_logXML_i(o,v);
}

void ConfigUI::cb_saveAllXML_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::saveAllXMLdata, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_saveAllXML(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_saveAllXML_i(o,v);
}

void ConfigUI::cb_enableGUI_i(Fl_Check_Button* o, void*) {
  //
                        int tmp = o->value();
                        int doit = true;
                        if (tmp == 0)
                            doit = fl_choice("Are you sure you want to disable?\nThis can only be restored via the command line.", NULL, "No", "Yes") > 1;
                        if (doit)
                            send_data(0, CONFIG::control::enableGUI, o->value(), TOPLEVEL::type::Integer);
                        else
                            o->value(1);
}
void ConfigUI::cb_enableGUI(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_enableGUI_i(o,v);
}

void ConfigUI::cb_enableCLI_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::enableCLI, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_enableCLI(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_enableCLI_i(o,v);
}

void ConfigUI::cb_enableAuto_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::enableAutoInstance, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_enableAuto(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_enableAuto_i(o,v);
}

void ConfigUI::cb_singleMaster_i(Fl_Check_Button* o, void*) {
  //
          send_data(0, CONFIG::control::enableSinglePath, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_singleMaster(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_singleMaster_i(o,v);
}

void ConfigUI::cb_H_instrument_i(Fl_Check_Button* o, void*) {
  //
                       send_data(TOPLEVEL::action::lowPrio, CONFIG::control::historyLock, o->value(), TOPLEVEL::type::Integer, TOPLEVEL::section::config,TOPLEVEL::XML::Instrument);
}
void ConfigUI::cb_H_instrument(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_H_instrument_i(o,v);
}

void ConfigUI::cb_H_patchset_i(Fl_Check_Button* o, void*) {
  //
                       send_data(TOPLEVEL::action::lowPrio, CONFIG::control::historyLock, o->value(), TOPLEVEL::type::Integer, TOPLEVEL::section::config,TOPLEVEL::XML::Patch);
}
void ConfigUI::cb_H_patchset(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_H_patchset_i(o,v);
}

void ConfigUI::cb_H_scale_i(Fl_Check_Button* o, void*) {
  //
                       send_data(TOPLEVEL::action::lowPrio, CONFIG::control::historyLock, o->value(), TOPLEVEL::type::Integer, TOPLEVEL::section::config,TOPLEVEL::XML::Scale);
}
void ConfigUI::cb_H_scale(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_H_scale_i(o,v);
}

void ConfigUI::cb_H_state_i(Fl_Check_Button* o, void*) {
  //
                       send_data(TOPLEVEL::action::lowPrio, CONFIG::control::historyLock, o->value(), TOPLEVEL::type::Integer, TOPLEVEL::section::config,TOPLEVEL::XML::State);
}
void ConfigUI::cb_H_state(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_H_state_i(o,v);
}

void ConfigUI::cb_H_vector_i(Fl_Check_Button* o, void*) {
  //
                       send_data(TOPLEVEL::action::lowPrio, CONFIG::control::historyLock, o->value(), TOPLEVEL::type::Integer, TOPLEVEL::section::config,TOPLEVEL::XML::Vector);
}
void ConfigUI::cb_H_vector(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_H_vector_i(o,v);
}

void ConfigUI::cb_H_mlearn_i(Fl_Check_Button* o, void*) {
  //
                       send_data(TOPLEVEL::action::lowPrio, CONFIG::control::historyLock, o->value(), TOPLEVEL::type::Integer, TOPLEVEL::section::config,TOPLEVEL::XML::MLearn);
}
void ConfigUI::cb_H_mlearn(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_H_mlearn_i(o,v);
}

void ConfigUI::cb_jackSource_i(Fl_Input* o, void*) {
  //
                        string tmp = string(o->value());
                        send_data(TOPLEVEL::action::lowPrio, CONFIG::control::jackMidiSource, 0, TOPLEVEL::type::Integer, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, textMsgBuffer.push(tmp));
}
void ConfigUI::cb_jackSource(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_jackSource_i(o,v);
}

void ConfigUI::cb_jackMidi_i(Fl_Check_Button* o, void*) {
  //
                        send_data(TOPLEVEL::action::forceUpdate, CONFIG::control::jackPreferredMidi, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_jackMidi(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_jackMidi_i(o,v);
}

void ConfigUI::cb_jackServer_i(Fl_Input* o, void*) {
  //
                        string tmp = string(o->value());
                        send_data(TOPLEVEL::action::lowPrio, CONFIG::control::jackServer, 0, TOPLEVEL::type::Integer, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, textMsgBuffer.push(tmp));
}
void ConfigUI::cb_jackServer(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_jackServer_i(o,v);
}

void ConfigUI::cb_jackAudio_i(Fl_Check_Button* o, void*) {
  //
                        send_data(TOPLEVEL::action::forceUpdate, CONFIG::control::jackPreferredAudio, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_jackAudio(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_jackAudio_i(o,v);
}

void ConfigUI::cb_connectJackAudio_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::jackAutoConnectAudio, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_connectJackAudio(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_connectJackAudio_i(o,v);
}

void ConfigUI::cb_alsaSource_i(Fl_Input* o, void*) {
  //
                        string tmp = string(o->value());
                        send_data(TOPLEVEL::action::lowPrio, CONFIG::control::alsaMidiSource, 0, TOPLEVEL::type::Integer, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, textMsgBuffer.push(tmp));
}
void ConfigUI::cb_alsaSource(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_alsaSource_i(o,v);
}

void ConfigUI::cb_alsaMidi_i(Fl_Check_Button* o, void*) {
  //
                        send_data(TOPLEVEL::action::forceUpdate, CONFIG::control::alsaPreferredMidi, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_alsaMidi(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_alsaMidi_i(o,v);
}

void ConfigUI::cb_alsaDevice_i(Fl_Input* o, void*) {
  //
                        string tmp = string(o->value());
                        send_data(TOPLEVEL::action::lowPrio, CONFIG::control::alsaAudioDevice, 0, TOPLEVEL::type::Integer, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, textMsgBuffer.push(tmp));
}
void ConfigUI::cb_alsaDevice(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_alsaDevice_i(o,v);
}

void ConfigUI::cb_alsaAudio_i(Fl_Check_Button* o, void*) {
  //
                        send_data(TOPLEVEL::action::forceUpdate, CONFIG::control::alsaPreferredAudio, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_alsaAudio(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_alsaAudio_i(o,v);
}

void ConfigUI::cb_alsaRate_i(Fl_Check_Browser* o, void*) {
  //
                        int chk = o->value();
                        o->check_none();
                        o->set_checked(chk);
                        if (chk > 4)
                            chk = 4;
                        send_data(0, CONFIG::control::alsaSampleRate, chk - 1, TOPLEVEL::type::Integer);
}
void ConfigUI::cb_alsaRate(Fl_Check_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_alsaRate_i(o,v);
}

void ConfigUI::cb_MIDI_i(Fl_Group*, void*) {
  //
                        EPCvalue = synth->getRuntime().midi_upper_voice_C;
                        if (EPCvalue >= 128)
                        {
                            EPCspinner->value(110);
                            EPCspinner->deactivate();
                        }
                        else
                        {
                            EPCspinner->value(EPCvalue);
                            EPCspinner->activate();
                        }
                        /*BankRootvalue = synth->getRuntime().midi_bank_root;
                        if (BankRootvalue >= 128)
                        {
                            BankRoot->value(0);
                            BankRoot->deactivate();
                        }
                        else
                        {
                            BankRoot->value(BankRootvalue);
                            BankRoot->activate();
                        }*/;
}
void ConfigUI::cb_MIDI(Fl_Group* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->user_data()))->cb_MIDI_i(o,v);
}

void ConfigUI::cb_bankrootchange_i(Fl_Choice* o, void*) {
  //
                        int candidate;
                        switch (o->value())
                        {
                            case 0:
                                candidate = 32;
                                break;
                            case 1:
                                candidate = 0;
                                break;
                            default:
                                candidate = 128;
                                break;
                        }
                        string name = testCC(candidate, CONFIG::control::bankRootCC);
                        if (!name.empty())
                        {
                            o->value(oldBank);
                            o->redraw();
                            switch(oldBank)
                            {
                                case 0:
                                    candidate = 32;
                                    break;
                                case 1:
                                    candidate = 0;
                                    break;
                                default:
                                    candidate = 128;
                                    break;
                            }
                            fl_alert("In use for %s",name.c_str());
                        }
                        send_data(0, CONFIG::control::bankRootCC, candidate, TOPLEVEL::type::Integer);
}
void ConfigUI::cb_bankrootchange(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_bankrootchange_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_bankrootchange[] = {
 {"LSB", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"MSB", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"Off", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* ConfigUI::bankrootlsb = ConfigUI::menu_bankrootchange + 0;
Fl_Menu_Item* ConfigUI::bankrootusb = ConfigUI::menu_bankrootchange + 1;
Fl_Menu_Item* ConfigUI::bankrootoff = ConfigUI::menu_bankrootchange + 2;

void ConfigUI::cb_bankchange_i(Fl_Choice* o, void*) {
  //
                        int candidate;
                        switch (o->value())
                        {
                            case 0:
                                candidate = 32;
                                break;
                            case 1:
                                candidate = 0;
                                break;
                            default:
                                candidate = 128;
                                break;
                        }
                        string name = testCC(candidate, CONFIG::control::bankCC);
                        if (!name.empty())
                        {
                            o->value(oldBank);
                            o->redraw();
                            switch(oldBank)
                            {
                                case 0:
                                    candidate = 32;
                                    break;
                                case 1:
                                    candidate = 0;
                                    break;
                                default:
                                    candidate = 128;
                                    break;
                            }
                            fl_alert("In use for %s",name.c_str());
                        }
                        send_data(0, CONFIG::control::bankCC, candidate, TOPLEVEL::type::Integer);
}
void ConfigUI::cb_bankchange(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_bankchange_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_bankchange[] = {
 {"LSB", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"MSB", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {"Off", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* ConfigUI::banklsb = ConfigUI::menu_bankchange + 0;
Fl_Menu_Item* ConfigUI::bankusb = ConfigUI::menu_bankchange + 1;
Fl_Menu_Item* ConfigUI::bankoff = ConfigUI::menu_bankchange + 2;

void ConfigUI::cb_progenable_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::enableProgramChange, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_progenable(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_progenable_i(o,v);
}

void ConfigUI::cb_progpartenable_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::instChangeEnablesPart, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_progpartenable(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_progpartenable_i(o,v);
}

void ConfigUI::cb_EPCspinner_i(Fl_Spinner*, void*) {
  //
                        Epend->show();
}
void ConfigUI::cb_EPCspinner(Fl_Spinner* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_EPCspinner_i(o,v);
}

void ConfigUI::cb_Epend_i(Fl_Button* o, void*) {
  //
                        int candidate = EPCspinner->value();
                        if (candidate == EPCvalue)
                        {
                            o->hide();
                            return;
                        }
                        string name = testCC(candidate, CONFIG::control::extendedProgramChangeCC);
                        if (!name.empty())
                        {
                            fl_alert("In use for %s",name.c_str());
                            if (EPCvalue < 128)
                            {
                                EPCspinner->value(EPCvalue);
                                EPCspinner->redraw();
                            }
                            return;
                        }
                        EPCvalue = candidate;
                        o->hide();
                        send_data(0, CONFIG::control::extendedProgramChangeCC, EPCvalue, TOPLEVEL::type::Integer);
}
void ConfigUI::cb_Epend(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Epend_i(o,v);
}

void ConfigUI::cb_Epcheck_i(Fl_Check_Button* o, void*) {
  // for some weird reason this *must* be the last item in the group
                        if (o->value() == 0)
                        {
                            EPCspinner->value(110);
                            EPCspinner->deactivate();
                            Epend->hide();
                            send_data(0, CONFIG::control::extendedProgramChangeCC, 128, TOPLEVEL::type::Integer);
                        }
                        else
                        {
                            EPCspinner->activate();
                            Epend->show();
                            EPCspinner->value(110);
                            EPCvalue = 128;
                        }
                        EPCspinner->redraw();
}
void ConfigUI::cb_Epcheck(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Epcheck_i(o,v);
}

void ConfigUI::cb_enableNRPN_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::enableNRPNs, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_enableNRPN(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_enableNRPN_i(o,v);
}

void ConfigUI::cb_ignoreReset_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::ignoreResetAllCCs, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_ignoreReset(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_ignoreReset_i(o,v);
}

void ConfigUI::cb_midiMon_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::logIncomingCCs, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_midiMon(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_midiMon_i(o,v);
}

void ConfigUI::cb_midiLearned_i(Fl_Check_Button* o, void*) {
  //
                        send_data(0, CONFIG::control::showLearnEditor, o->value(), TOPLEVEL::type::Integer);
}
void ConfigUI::cb_midiLearned(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_midiLearned_i(o,v);
}

void ConfigUI::cb_Close_i(Fl_Button*, void*) {
  //
                    configwindow->do_callback();
}
void ConfigUI::cb_Close(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void ConfigUI::cb_Save_i(Fl_Button* o, void*) {
  //
                    send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate, CONFIG::control::saveCurrentConfig, o->value(), TOPLEVEL::type::Integer, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, textMsgBuffer.push("DUMMY"));
                    configwindow->do_callback();
}
void ConfigUI::cb_Save(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Save_i(o,v);
}

void ConfigUI::cb_presetbrowse_i(Fl_Browser* o, void*) {
  //
                    activatebutton_presetdir(o->value() != 0);
}
void ConfigUI::cb_presetbrowse(Fl_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_presetbrowse_i(o,v);
}

void ConfigUI::cb_addpreset_i(Fl_Button* o, void*) {
  //
                    const char *dirname;
                    dirname = fl_dir_chooser("Add a preset directory :", NULL, 0);
                    if (!dirname)
                        return;

                    send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate,CONFIG::control::addPresetRootDir, 0, TOPLEVEL::type::Integer, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, textMsgBuffer.push(dirname));
                    if (presetbrowse->size() >= MAX_PRESET_DIRS)
                        o->deactivate();
}
void ConfigUI::cb_addpreset(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_addpreset_i(o,v);
}

void ConfigUI::cb_removepresetbutton_i(Fl_Button*, void*) {
  //
                    if (presetbrowse->value() != 0)
                        send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate,CONFIG::control::removePresetRootDir, presetbrowse->value() - 1, TOPLEVEL::type::Integer);
}
void ConfigUI::cb_removepresetbutton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_removepresetbutton_i(o,v);
}

void ConfigUI::cb_makedefaultpresetbutton_i(Fl_Button*, void*) {
  //
                    send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate,CONFIG::control::currentPresetRoot, presetbrowse->value() - 1, TOPLEVEL::type::Integer);
}
void ConfigUI::cb_makedefaultpresetbutton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_makedefaultpresetbutton_i(o,v);
}

void ConfigUI::cb_Save1_i(Fl_Button*, void*) {
  //
                    synth->getRuntime().saveConfig();
                    presets->hide();
}
void ConfigUI::cb_Save1(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Save1_i(o,v);
}

void ConfigUI::cb_Close1_i(Fl_Button*, void*) {
  //
                    presets->hide();
}
void ConfigUI::cb_Close1(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Close1_i(o,v);
}

Fl_Double_Window* ConfigUI::make_window() {
  { Fl_Double_Window* o = configwindow = new Fl_Double_Window(390, 330, "Yoshimi Settings");
    configwindow->callback((Fl_Callback*)cb_configwindow, (void*)(this));
    { Fl_Tabs* o = new Fl_Tabs(5, 5, 385, 298);
      { Fl_Group* o = new Fl_Group(5, 25, 382, 277, "Main settings");
        o->labelsize(12);
        { Fl_Choice* o = osc_size = new Fl_Choice(250, 45, 100, 20, "* AddSynth Oscillator Size");
          osc_size->tooltip("ADSynth Oscillator Size (samples)");
          osc_size->down_box(FL_BORDER_BOX);
          osc_size->labelsize(12);
          osc_size->textsize(11);
          osc_size->callback((Fl_Callback*)cb_osc_size);
          osc_size->menu(menu_osc_size);
          o->value( (int)(logf(synth->getRuntime().Oscilsize / 256.0f - 1.0f) / logf(2.0f)) + 1);
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Choice* osc_size
        { Fl_Choice* o = buff_size = new Fl_Choice(249, 75, 100, 20, "* Internal Buffer Size");
          buff_size->tooltip("Number of samples");
          buff_size->down_box(FL_BORDER_BOX);
          buff_size->labelsize(12);
          buff_size->textsize(12);
          buff_size->callback((Fl_Callback*)cb_buff_size);
          buff_size->menu(menu_buff_size);
          o->value( (int)(logf(synth->getRuntime().Buffersize / 16.0f - 1.0f) / logf(2.0f)) + 1);
          if (synth->getUniqueId() != 0) o->hide(); else if (synth->getIsLV2Plugin()) o->deactivate();
        } // Fl_Choice* buff_size
        { Fl_Choice* o = pad_interpol = new Fl_Choice(250, 105, 100, 20, "PADsynth Interpolation");
          pad_interpol->down_box(FL_BORDER_BOX);
          pad_interpol->labelsize(12);
          pad_interpol->textfont(1);
          pad_interpol->textsize(12);
          pad_interpol->callback((Fl_Callback*)cb_pad_interpol);
          pad_interpol->menu(menu_pad_interpol);
          o->value(synth->getRuntime().Interpolation);
        } // Fl_Choice* pad_interpol
        { Fl_Choice* o = v_keyboard = new Fl_Choice(250, 135, 100, 20, "Virtual Keyboard Layout");
          v_keyboard->down_box(FL_BORDER_BOX);
          v_keyboard->labelsize(12);
          v_keyboard->textfont(1);
          v_keyboard->textsize(13);
          v_keyboard->callback((Fl_Callback*)cb_v_keyboard);
          v_keyboard->menu(menu_v_keyboard);
          o->value(synth->getRuntime().VirKeybLayout);
        } // Fl_Choice* v_keyboard
        { Fl_Counter* o = compression = new Fl_Counter(284, 165, 65, 20, "XML Compression Level");
          compression->tooltip("gzip compression level (0 - uncompressed)");
          compression->type(1);
          compression->labelsize(12);
          compression->minimum(0);
          compression->maximum(9);
          compression->step(1);
          compression->textfont(1);
          compression->textsize(12);
          compression->callback((Fl_Callback*)cb_compression);
          compression->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().GzipCompression);
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Counter* compression
        { Fl_Choice* o = reports = new Fl_Choice(200, 195, 150, 20, "Send reports to:");
          reports->tooltip("Some system errors always go to stdout");
          reports->down_box(FL_BORDER_BOX);
          reports->labelsize(12);
          reports->textfont(1);
          reports->textsize(13);
          reports->callback((Fl_Callback*)cb_reports);
          reports->menu(menu_reports);
          o->value(synth->getRuntime().toConsole);
        } // Fl_Choice* reports
        { Fl_Choice* o = instrument = new Fl_Choice(200, 225, 150, 20, "Saved Instrument Format");
          instrument->tooltip("Yoshimi format includes Controllers and Humanise");
          instrument->down_box(FL_BORDER_BOX);
          instrument->labelsize(12);
          instrument->textfont(1);
          instrument->textsize(13);
          instrument->callback((Fl_Callback*)cb_instrument);
          instrument->menu(menu_instrument);
          o->value(synth->getRuntime().instrumentFormat - 1);
        } // Fl_Choice* instrument
        { Fl_Box* o = settingsNote = new Fl_Box(50, 276, 287, 17, "* Changing these settings requires a restart");
          settingsNote->labelfont(1);
          settingsNote->labelsize(11);
          settingsNote->labelcolor((Fl_Color)38);
          settingsNote->align(Fl_Align(FL_ALIGN_WRAP));
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Box* settingsNote
        o->end();
      } // Fl_Group* o
      { Fl_Group* o = new Fl_Group(5, 25, 382, 277, "Switches");
        o->labelsize(12);
        o->hide();
        { Fl_Check_Button* o = setDefaultState = new Fl_Check_Button(190, 60, 27, 25, "* Start With Default State");
          setDefaultState->tooltip("If you change this you must re-save the default state\nor when that loads it \
will revert to the previous value");
          setDefaultState->down_box(FL_DOWN_BOX);
          setDefaultState->labelsize(12);
          setDefaultState->callback((Fl_Callback*)cb_setDefaultState);
          setDefaultState->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().loadDefaultState);
          if (synth->getIsLV2Plugin()) o->deactivate();
        } // Fl_Check_Button* setDefaultState
        { Fl_Check_Button* o = nonFatal = new Fl_Check_Button(190, 80, 27, 25, "Hide Non Fatal Errors");
          nonFatal->down_box(FL_DOWN_BOX);
          nonFatal->labelsize(12);
          nonFatal->callback((Fl_Callback*)cb_nonFatal);
          nonFatal->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().hideErrors);
          if (synth->getIsLV2Plugin()) o->deactivate();
        } // Fl_Check_Button* nonFatal
        { Fl_Check_Button* o = showSplash = new Fl_Check_Button(190, 100, 27, 25, "Show Splash Screen");
          showSplash->down_box(FL_DOWN_BOX);
          showSplash->labelsize(12);
          showSplash->callback((Fl_Callback*)cb_showSplash);
          showSplash->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().showSplash);
          if (synth->getUniqueId() != 0) o->hide(); else if (synth->getIsLV2Plugin()) o->deactivate();
        } // Fl_Check_Button* showSplash
        { Fl_Check_Button* o = logTimes = new Fl_Check_Button(190, 120, 27, 25, "Log Load times");
          logTimes->down_box(FL_DOWN_BOX);
          logTimes->labelsize(12);
          logTimes->callback((Fl_Callback*)cb_logTimes);
          logTimes->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().showTimes);
        } // Fl_Check_Button* logTimes
        { Fl_Check_Button* o = logXML = new Fl_Check_Button(190, 140, 27, 25, "Log XML Headers");
          logXML->down_box(FL_DOWN_BOX);
          logXML->labelsize(12);
          logXML->callback((Fl_Callback*)cb_logXML);
          logXML->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().logXMLheaders);
          if (synth->getIsLV2Plugin()) o->deactivate();
        } // Fl_Check_Button* logXML
        { Fl_Check_Button* o = saveAllXML = new Fl_Check_Button(190, 160, 27, 25, "Include all data in XML files");
          saveAllXML->down_box(FL_DOWN_BOX);
          saveAllXML->labelsize(12);
          saveAllXML->callback((Fl_Callback*)cb_saveAllXML);
          saveAllXML->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().xmlmax);
        } // Fl_Check_Button* saveAllXML
        { Fl_Check_Button* o = enableGUI = new Fl_Check_Button(190, 180, 27, 25, "* Enable GUI");
          enableGUI->tooltip("Enable starting with this graphical  interface");
          enableGUI->down_box(FL_DOWN_BOX);
          enableGUI->labelsize(12);
          enableGUI->callback((Fl_Callback*)cb_enableGUI);
          enableGUI->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().showGui);
          if (synth->getUniqueId() != 0) o->hide(); else if (synth->getIsLV2Plugin()) o->deactivate();
        } // Fl_Check_Button* enableGUI
        { Fl_Check_Button* o = enableCLI = new Fl_Check_Button(190, 200, 27, 25, "* Enable CLI");
          enableCLI->tooltip("Enable starting with interactive command line interface");
          enableCLI->down_box(FL_DOWN_BOX);
          enableCLI->labelsize(12);
          enableCLI->callback((Fl_Callback*)cb_enableCLI);
          enableCLI->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().showCLI);
          if (synth->getUniqueId() != 0) o->hide(); else if (synth->getIsLV2Plugin()) o->deactivate();
        } // Fl_Check_Button* enableCLI
        { Fl_Check_Button* o = enableAuto = new Fl_Check_Button(190, 220, 27, 25, "Enable Auto Instance");
          enableAuto->tooltip("Allow main instance to start all those open when last closed.");
          enableAuto->down_box(FL_DOWN_BOX);
          enableAuto->labelsize(12);
          enableAuto->callback((Fl_Callback*)cb_enableAuto);
          enableAuto->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().autoInstance);
          if (synth->getUniqueId() != 0) o->hide(); else if (synth->getIsLV2Plugin()) o->deactivate();
        } // Fl_Check_Button* enableAuto
        { Fl_Check_Button* o = singleMaster = new Fl_Check_Button(190, 240, 27, 25, "* Enable Single Master");
          singleMaster->tooltip("Redirect new start from desktop to create new instance instead.");
          singleMaster->down_box(FL_DOWN_BOX);
          singleMaster->labelsize(12);
          singleMaster->callback((Fl_Callback*)cb_singleMaster);
          singleMaster->align(Fl_Align(FL_ALIGN_LEFT));
          singleMaster->hide();
          o->value(fetchData(0, CONFIG::control::enableSinglePath, TOPLEVEL::section::config));
        } // Fl_Check_Button* singleMaster
        { Fl_Text_Display* o = new Fl_Text_Display(278, 110, 50, 1, "History Locks");
          o->box(FL_NO_BOX);
          o->align(Fl_Align(129));
        } // Fl_Text_Display* o
        { Fl_Check_Button* o = H_instrument = new Fl_Check_Button(240, 120, 27, 25, "Instrument");
          H_instrument->down_box(FL_DOWN_BOX);
          H_instrument->labelsize(12);
          H_instrument->callback((Fl_Callback*)cb_H_instrument);
          H_instrument->align(Fl_Align(FL_ALIGN_RIGHT));
          o->value(fetchData(0, CONFIG::control::historyLock, TOPLEVEL::section::config, TOPLEVEL::XML::Instrument, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, TOPLEVEL::action::lowPrio) > 0.5f);
        } // Fl_Check_Button* H_instrument
        { Fl_Check_Button* o = H_patchset = new Fl_Check_Button(240, 140, 27, 25, "Patch Set");
          H_patchset->down_box(FL_DOWN_BOX);
          H_patchset->labelsize(12);
          H_patchset->callback((Fl_Callback*)cb_H_patchset);
          H_patchset->align(Fl_Align(FL_ALIGN_RIGHT));
          o->value(fetchData(0, CONFIG::control::historyLock, TOPLEVEL::section::config, TOPLEVEL::XML::Patch, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, TOPLEVEL::action::lowPrio) > 0.5f);
        } // Fl_Check_Button* H_patchset
        { Fl_Check_Button* o = H_scale = new Fl_Check_Button(240, 160, 27, 25, "Scale");
          H_scale->down_box(FL_DOWN_BOX);
          H_scale->labelsize(12);
          H_scale->callback((Fl_Callback*)cb_H_scale);
          H_scale->align(Fl_Align(FL_ALIGN_RIGHT));
          o->value(fetchData(0, CONFIG::control::historyLock, TOPLEVEL::section::config, TOPLEVEL::XML::Scale, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, TOPLEVEL::action::lowPrio) > 0.5f);
        } // Fl_Check_Button* H_scale
        { Fl_Check_Button* o = H_state = new Fl_Check_Button(240, 180, 27, 25, "State");
          H_state->down_box(FL_DOWN_BOX);
          H_state->labelsize(12);
          H_state->callback((Fl_Callback*)cb_H_state);
          H_state->align(Fl_Align(FL_ALIGN_RIGHT));
          o->value(fetchData(0, CONFIG::control::historyLock, TOPLEVEL::section::config, TOPLEVEL::XML::State, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, TOPLEVEL::action::lowPrio) > 0.5f);
        } // Fl_Check_Button* H_state
        { Fl_Check_Button* o = H_vector = new Fl_Check_Button(240, 200, 27, 25, "Vector");
          H_vector->down_box(FL_DOWN_BOX);
          H_vector->labelsize(12);
          H_vector->callback((Fl_Callback*)cb_H_vector);
          H_vector->align(Fl_Align(FL_ALIGN_RIGHT));
          o->value(fetchData(0, CONFIG::control::historyLock, TOPLEVEL::section::config, TOPLEVEL::XML::Vector, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, TOPLEVEL::action::lowPrio) > 0.5f);
        } // Fl_Check_Button* H_vector
        { Fl_Check_Button* o = H_mlearn = new Fl_Check_Button(240, 220, 27, 25, "Midi Learn");
          H_mlearn->down_box(FL_DOWN_BOX);
          H_mlearn->labelsize(12);
          H_mlearn->callback((Fl_Callback*)cb_H_mlearn);
          H_mlearn->align(Fl_Align(FL_ALIGN_RIGHT));
          o->value(fetchData(0, CONFIG::control::historyLock, TOPLEVEL::section::config, TOPLEVEL::XML::MLearn, UNUSED, UNUSED, UNUSED, UNUSED, UNUSED, TOPLEVEL::action::lowPrio) > 0.5f);
        } // Fl_Check_Button* H_mlearn
        { Fl_Box* o = new Fl_Box(50, 276, 287, 17, "* Changing these settings requires a restart");
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)38);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        { Fl_Group* o = new Fl_Group(230, 70, 130, 180);
          o->tooltip("When locked new entries will not not be added or change the list order");
          o->box(FL_EMBOSSED_FRAME);
          o->end();
        } // Fl_Group* o
        o->end();
      } // Fl_Group* o
      { jackTab = new Fl_Group(5, 25, 385, 277, "Jack");
        jackTab->labelsize(12);
        jackTab->hide();
        { Fl_Input* o = jackSource = new Fl_Input(195, 62, 120, 22, "Jack MIDI Source");
          jackSource->tooltip("Device Jack tries to connect to for input.");
          jackSource->labelsize(12);
          jackSource->textfont(1);
          jackSource->textsize(12);
          jackSource->callback((Fl_Callback*)cb_jackSource);
          o->value(synth->getRuntime().jackMidiDevice.c_str());
        } // Fl_Input* jackSource
        { Fl_Check_Button* o = jackMidi = new Fl_Check_Button(195, 88, 37, 26, "Set as preferred MIDI");
          jackMidi->down_box(FL_DOWN_BOX);
          jackMidi->labelsize(12);
          jackMidi->callback((Fl_Callback*)cb_jackMidi);
          jackMidi->align(Fl_Align(FL_ALIGN_LEFT));
          if (synth->getRuntime().midiEngine == jack_midi) o->value(1);
        } // Fl_Check_Button* jackMidi
        { Fl_Input* o = jackServer = new Fl_Input(195, 182, 120, 22, "Jack Server");
          jackServer->tooltip("Name of the jack server to connect to - default, ...");
          jackServer->labelsize(12);
          jackServer->textfont(1);
          jackServer->textsize(12);
          jackServer->callback((Fl_Callback*)cb_jackServer);
          o->value(synth->getRuntime().jackServer.c_str());
        } // Fl_Input* jackServer
        { Fl_Check_Button* o = jackAudio = new Fl_Check_Button(195, 209, 37, 26, "Set as preferred audio");
          jackAudio->down_box(FL_DOWN_BOX);
          jackAudio->labelsize(12);
          jackAudio->callback((Fl_Callback*)cb_jackAudio);
          jackAudio->align(Fl_Align(FL_ALIGN_LEFT));
          if (synth->getRuntime().audioEngine == jack_audio) o->value(1);
        } // Fl_Check_Button* jackAudio
        { Fl_Check_Button* o = connectJackAudio = new Fl_Check_Button(195, 233, 37, 26, "Autoconnect audio");
          connectJackAudio->down_box(FL_DOWN_BOX);
          connectJackAudio->labelsize(12);
          connectJackAudio->callback((Fl_Callback*)cb_connectJackAudio);
          connectJackAudio->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().connectJackaudio);
        } // Fl_Check_Button* connectJackAudio
        { Fl_Box* o = new Fl_Box(60, 276, 267, 17, "Changing settings requires a restart");
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)38);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        jackTab->end();
      } // Fl_Group* jackTab
      { alsaTab = new Fl_Group(5, 25, 384, 277, "Alsa");
        alsaTab->labelsize(12);
        alsaTab->hide();
        { Fl_Input* o = alsaSource = new Fl_Input(195, 52, 120, 22, "Alsa MIDI Source");
          alsaSource->tooltip("Device Alsa tries to connect to for input.");
          alsaSource->labelsize(12);
          alsaSource->textfont(1);
          alsaSource->textsize(12);
          alsaSource->callback((Fl_Callback*)cb_alsaSource);
          o->value(synth->getRuntime().alsaMidiDevice.c_str());
        } // Fl_Input* alsaSource
        { Fl_Check_Button* o = alsaMidi = new Fl_Check_Button(195, 80, 37, 26, "Set as preferred MIDI");
          alsaMidi->down_box(FL_DOWN_BOX);
          alsaMidi->labelsize(12);
          alsaMidi->callback((Fl_Callback*)cb_alsaMidi);
          alsaMidi->align(Fl_Align(FL_ALIGN_LEFT));
          if (synth->getRuntime().midiEngine == alsa_midi) o->value(1);
        } // Fl_Check_Button* alsaMidi
        { Fl_Input* o = alsaDevice = new Fl_Input(195, 143, 120, 22, "Alsa Audio Device");
          alsaDevice->tooltip("Alsa audio device - default, hw:0, ...");
          alsaDevice->labelsize(12);
          alsaDevice->textfont(1);
          alsaDevice->textsize(12);
          alsaDevice->callback((Fl_Callback*)cb_alsaDevice);
          o->value(synth->getRuntime().alsaAudioDevice.c_str());
        } // Fl_Input* alsaDevice
        { Fl_Check_Button* o = alsaAudio = new Fl_Check_Button(195, 169, 37, 26, "Set as preferred audio");
          alsaAudio->down_box(FL_DOWN_BOX);
          alsaAudio->labelsize(12);
          alsaAudio->callback((Fl_Callback*)cb_alsaAudio);
          alsaAudio->align(Fl_Align(FL_ALIGN_LEFT));
          if (synth->getRuntime().audioEngine == alsa_audio) o->value(1);
        } // Fl_Check_Button* alsaAudio
        { Fl_Check_Browser* o = alsaRate = new Fl_Check_Browser(195, 199, 121, 66, "Samplerate");
          alsaRate->labelsize(12);
          alsaRate->textfont(1);
          alsaRate->textsize(12);
          alsaRate->callback((Fl_Callback*)cb_alsaRate);
          alsaRate->align(Fl_Align(FL_ALIGN_LEFT));
          alsaRate->when(FL_WHEN_CHANGED);
          //
                    o->add("192000");
                    o->add("96000");
                    o->add("48000");
                    o->add("44100");
                    switch (synth->getRuntime().Samplerate)
                    {
                        case 192000: o->set_checked(1); break;
                        case 96000: o->set_checked(2); break;
                        case 44100: o->set_checked(4); break;
                        case 48000:
                        default: o->set_checked(3); break;
                    }
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Check_Browser* alsaRate
        { Fl_Box* o = new Fl_Box(60, 276, 267, 17, "Changing settings requires a restart");
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)38);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        alsaTab->end();
      } // Fl_Group* alsaTab
      { Fl_Group* o = new Fl_Group(5, 25, 381, 275, "MIDI");
        o->tooltip("MIDI CC preferences");
        o->labelsize(12);
        o->callback((Fl_Callback*)cb_MIDI);
        o->hide();
        { Fl_Choice* o = bankrootchange = new Fl_Choice(234, 57, 53, 18, "Bank Root Change");
          bankrootchange->tooltip("CC0 = msb, CC32 = lsb");
          bankrootchange->down_box(FL_BORDER_BOX);
          bankrootchange->labelsize(12);
          bankrootchange->textfont(1);
          bankrootchange->textsize(12);
          bankrootchange->callback((Fl_Callback*)cb_bankrootchange);
          bankrootchange->align(Fl_Align(132));
          bankrootchange->menu(menu_bankrootchange);
          int bankRoot = synth->getRuntime().midi_bank_root;
          if (bankRoot == 32) o->value(0); else if (bankRoot == 0) o->value(1); else o->value(2);
          oldBank = o->value();
        } // Fl_Choice* bankrootchange
        { Fl_Choice* o = bankchange = new Fl_Choice(235, 80, 53, 18, "Bank Change");
          bankchange->tooltip("CC0 = msb, CC32 = lsb");
          bankchange->down_box(FL_BORDER_BOX);
          bankchange->labelsize(12);
          bankchange->textfont(1);
          bankchange->textsize(12);
          bankchange->callback((Fl_Callback*)cb_bankchange);
          bankchange->align(Fl_Align(132));
          bankchange->menu(menu_bankchange);
          if (synth->getRuntime().midi_bank_C == 32) o->value(0); else if (synth->getRuntime().midi_bank_C == 0) o->value(1); else o->value(2);
          oldBank = o->value();
        } // Fl_Choice* bankchange
        { Fl_Check_Button* o = progenable = new Fl_Check_Button(234, 110, 18, 18, "Enable Program Change");
          progenable->tooltip("MIDI program change enable/disable");
          progenable->down_box(FL_DOWN_BOX);
          progenable->value(1);
          progenable->labelsize(12);
          progenable->callback((Fl_Callback*)cb_progenable);
          progenable->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().EnableProgChange);
        } // Fl_Check_Button* progenable
        { Fl_Check_Button* o = progpartenable = new Fl_Check_Button(234, 130, 18, 18, "Enable Part On Program Change");
          progpartenable->tooltip("Part enabled if MIDI program changed");
          progpartenable->down_box(FL_DOWN_BOX);
          progpartenable->labelsize(12);
          progpartenable->callback((Fl_Callback*)cb_progpartenable);
          progpartenable->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().enable_part_on_voice_load);
        } // Fl_Check_Button* progpartenable
        { Fl_Spinner* o = EPCspinner = new Fl_Spinner(235, 180, 50, 18, "Extended Program Change");
          EPCspinner->labelsize(12);
          EPCspinner->minimum(0);
          EPCspinner->maximum(127);
          EPCspinner->value(110);
          EPCspinner->textfont(1);
          EPCspinner->textsize(12);
          EPCspinner->callback((Fl_Callback*)cb_EPCspinner);
          EPCvalue = synth->getRuntime().midi_upper_voice_C;
          if (EPCvalue < 128) o->value(EPCvalue); else o->value(110);
        } // Fl_Spinner* EPCspinner
        { Epend = new Fl_Button(300, 180, 70, 20, "Pending");
          Epend->tooltip("Click to set");
          Epend->box(FL_PLASTIC_UP_BOX);
          Epend->color((Fl_Color)90);
          Epend->labelsize(12);
          Epend->callback((Fl_Callback*)cb_Epend);
          Epend->hide();
        } // Fl_Button* Epend
        { Fl_Check_Button* o = Epcheck = new Fl_Check_Button(234, 160, 18, 18, "Enable Extended Program Change");
          Epcheck->down_box(FL_DOWN_BOX);
          Epcheck->labelsize(12);
          Epcheck->callback((Fl_Callback*)cb_Epcheck);
          Epcheck->align(Fl_Align(FL_ALIGN_LEFT));
          o->value((synth->getRuntime().midi_upper_voice_C < 128));
          if (o->value() == 0) EPCspinner->deactivate();
        } // Fl_Check_Button* Epcheck
        { Fl_Check_Button* o = enableNRPN = new Fl_Check_Button(234, 210, 18, 18, "Enable Incoming NRPNs");
          enableNRPN->down_box(FL_DOWN_BOX);
          enableNRPN->labelsize(12);
          enableNRPN->callback((Fl_Callback*)cb_enableNRPN);
          enableNRPN->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().enable_NRPN);
        } // Fl_Check_Button* enableNRPN
        { Fl_Check_Button* o = ignoreReset = new Fl_Check_Button(234, 230, 18, 18, "Ignore Reset all CCs");
          ignoreReset->down_box(FL_DOWN_BOX);
          ignoreReset->labelsize(12);
          ignoreReset->callback((Fl_Callback*)cb_ignoreReset);
          ignoreReset->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().ignoreResetCCs);
        } // Fl_Check_Button* ignoreReset
        { Fl_Check_Button* o = midiMon = new Fl_Check_Button(234, 250, 18, 18, "Log Incoming Events");
          midiMon->down_box(FL_DOWN_BOX);
          midiMon->labelsize(12);
          midiMon->callback((Fl_Callback*)cb_midiMon);
          midiMon->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().monitorCCin);
        } // Fl_Check_Button* midiMon
        { Fl_Check_Button* o = midiLearned = new Fl_Check_Button(234, 270, 18, 18, "Show Learn Editor");
          midiLearned->tooltip("Open the MIDI learn window for editing when a new CC has been learned");
          midiLearned->down_box(FL_DOWN_BOX);
          midiLearned->labelsize(12);
          midiLearned->callback((Fl_Callback*)cb_midiLearned);
          midiLearned->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().showLearnedCC);
        } // Fl_Check_Button* midiLearned
        EPCvalue = synth->getRuntime().midi_upper_voice_C;
        BankRootvalue = synth->getRuntime().midi_bank_root;
        o->end();
      } // Fl_Group* o
      o->end();
    } // Fl_Tabs* o
    { Fl_Button* o = new Fl_Button(275, 305, 105, 20, "Close Unsaved");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(155, 305, 105, 20, "Save and Close");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Save);
    } // Fl_Button* o
    o->copy_label(synth->makeUniqueName("Settings").c_str());
    if (synth->getIsLV2Plugin()){jackTab->deactivate();alsaTab->deactivate();}
    configwindow->end();
  } // Fl_Double_Window* configwindow
  { Fl_Double_Window* o = presets = new Fl_Double_Window(460, 295, "Presets");
    presets->user_data((void*)(this));
    { presetbrowse = new Fl_Browser(5, 5, 450, 200);
      presetbrowse->type(2);
      presetbrowse->labelsize(12);
      presetbrowse->textsize(12);
      presetbrowse->callback((Fl_Callback*)cb_presetbrowse);
    } // Fl_Browser* presetbrowse
    { addpreset = new Fl_Button(10, 220, 80, 35, "Add preset directory...");
      addpreset->box(FL_THIN_UP_BOX);
      addpreset->labelsize(12);
      addpreset->callback((Fl_Callback*)cb_addpreset);
      addpreset->align(Fl_Align(FL_ALIGN_WRAP));
    } // Fl_Button* addpreset
    { Fl_Button* o = removepresetbutton = new Fl_Button(110, 220, 80, 35, "Remove preset dir...");
      removepresetbutton->box(FL_THIN_UP_BOX);
      removepresetbutton->labelsize(12);
      removepresetbutton->callback((Fl_Callback*)cb_removepresetbutton);
      removepresetbutton->align(Fl_Align(FL_ALIGN_WRAP));
      o->deactivate();
    } // Fl_Button* removepresetbutton
    { Fl_Button* o = makedefaultpresetbutton = new Fl_Button(210, 220, 80, 35, "Make Current");
      makedefaultpresetbutton->box(FL_THIN_UP_BOX);
      makedefaultpresetbutton->labelsize(12);
      makedefaultpresetbutton->callback((Fl_Callback*)cb_makedefaultpresetbutton);
      makedefaultpresetbutton->align(Fl_Align(FL_ALIGN_WRAP));
      o->deactivate();
    } // Fl_Button* makedefaultpresetbutton
    { Fl_Button* o = new Fl_Button(225, 268, 105, 20, "Save and Close");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Save1);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(345, 268, 105, 20, "Close Unsaved");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close1);
    } // Fl_Button* o
    o->copy_label(synth->makeUniqueName("Presets").c_str());
    presets->end();
  } // Fl_Double_Window* presets
  return presets;
}

void ConfigUI::send_data(int action, int control, float value, int type, int part , int kit , int engine , int insert , int par , int miscmsg ) {
  //
              type |= TOPLEVEL::type::Write;
              if (part == UNUSED)
                  part = TOPLEVEL::section::config;
              collect_data(synth, value, action, (Fl::event_button() | type), control, part, kit, engine, insert, par, UNUSED, miscmsg);
}

float ConfigUI::fetchData(float value, int control, int part, int kititem , int engine , int insert , int parameter , int offset , int miscmsg , int request ) {
  //
          return collect_readData(synth, value, control, part, kititem, engine, insert, parameter, offset, miscmsg, request);
}

void ConfigUI::returns_update(CommandBlock *getData) {
  //
              int value_int = lrint(getData->data.value.F);
              bool wasFromHere = ((getData->data.source & TOPLEVEL::action::noAction) == TOPLEVEL::action::fromGUI);
              unsigned char control = getData->data.control;
              unsigned char kititem = getData->data.kit;
              unsigned char miscmsg = getData->data.miscmsg;
              string msg = textMsgBuffer.fetch(miscmsg);
  
              bool value_bool = value_int > 0;
              int tmp;
              string name;
              switch (control)
              {
                  case CONFIG::control::oscillatorSize:
                      tmp = 0;
                      while (value_int > 256)
                      {
                          value_int = value_int >> 1;
                          ++ tmp; // count the bits for switch number
                      }
                      osc_size->value(tmp);
                      break;
                  case 1:
                      tmp = CONFIG::control::bufferSize;
                      while (value_int > 16)
                      {
                          value_int = value_int >> 1;
                          ++ tmp; // count the bits for switch number
                      }
                      buff_size->value(tmp);
                      break;
                  case CONFIG::control::padSynthInterpolation:
                      pad_interpol->value(value_int);
                      break;
                  case CONFIG::control::virtualKeyboardLayout:
                      v_keyboard->value(value_int);
                      break;
                  case CONFIG::control::XMLcompressionLevel:
                      compression->value(value_int);
                      break;
                  case CONFIG::control::reportsDestination:
                      reports->value(value_bool);
                      synth->getGuiMaster()->setLogging(value_bool);
                      break;
                  case CONFIG::control::savedInstrumentFormat:
                      instrument->value(value_int - 1);
                      break;
                  case CONFIG::control::showEnginesTypes:
                      synth->getGuiMaster()->updateEngines(value_bool);
                      break;
  
                  case CONFIG::control::defaultStateStart:
                      setDefaultState->value(value_bool);
                      break;
                  case CONFIG::control::hideNonFatalErrors:
                      nonFatal->value(value_bool);
                      break;
                  case CONFIG::control::showSplash:
                      showSplash->value(value_bool);
                      break;
                  case CONFIG::control::logInstrumentLoadTimes:
                      logTimes->value(value_bool);
                      break;
                  case CONFIG::control::logXMLheaders:
                      logXML->value(value_bool);
                      break;
                  case CONFIG::control::saveAllXMLdata:
                      saveAllXML->value(value_bool);
                      break;
                  case CONFIG::control::enableGUI:
                      enableGUI->value(value_bool);
                      break;
                  case CONFIG::control::enableCLI:
                      enableCLI->value(value_bool);
                      break;
                  case CONFIG::control::enableAutoInstance:
                      enableAuto->value(value_bool);
                      break;
                  case CONFIG::control::enableSinglePath:
                      singleMaster->value(value_bool);
                      break;
  
                  case CONFIG::control::historyLock:
                      if (!wasFromHere)
                      {
                          switch (kititem)
                          {
                              case TOPLEVEL::XML::Instrument:
                                  H_instrument->value(value_int);
                                  break;
                              case TOPLEVEL::XML::Patch:
                                  H_patchset->value(value_int);
                                  break;
                              case TOPLEVEL::XML::Scale:
                                  H_scale->value(value_int);
                                  break;
                              case TOPLEVEL::XML::State:
                                  H_state->value(value_int);
                                  break;
                              case TOPLEVEL::XML::Vector:
                                  H_vector->value(value_int);
                                  break;
                              case TOPLEVEL::XML::MLearn:
                                  H_mlearn->value(value_int);
                                  break;
                              default:
                                  break;
                          }
                      }
                      break;
  
                  case CONFIG::control::jackMidiSource:
                      jackSource->value(msg.c_str());
                      break;
                  case CONFIG::control::jackPreferredMidi:
                      jackMidi->value(value_bool);
                      alsaMidi->value(!value_bool);
                      break;
                  case CONFIG::control::jackServer:
                      jackServer->value(msg.c_str());
                      break;
                  case CONFIG::control::jackPreferredAudio:
                      jackAudio->value(value_bool);
                      alsaAudio->value(!value_bool);
                      break;
                  case CONFIG::control::jackAutoConnectAudio:
                      connectJackAudio->value(value_bool);
                      break;
  
                  case CONFIG::control::alsaMidiSource:
                      alsaSource->value(msg.c_str());
                      break;
                  case CONFIG::control::alsaPreferredMidi:
                      alsaMidi->value(value_bool);
                      jackMidi->value(!value_bool);
                      break;
                  case CONFIG::control::alsaAudioDevice:
                      alsaDevice->value(msg.c_str());
                      break;
                  case CONFIG::control::alsaPreferredAudio:
                      alsaAudio->value(value_bool);
                      jackAudio->value(!value_bool);
                      break;
                  case CONFIG::control::alsaSampleRate:
                      alsaRate->check_none();
                      switch(value_int)
                      {
                          case 192000:
                              alsaRate->set_checked(1);
                              break;
                          case 96000:
                              alsaRate->set_checked(2);
                              break;
                          case 48000:
                              alsaRate->set_checked(3);
                              break;
                          case 44100:
                              alsaRate->set_checked(4);
                              break;
                      }
                      break;
                  case CONFIG::control::addPresetRootDir:
                  case CONFIG::control::removePresetRootDir:
                  case CONFIG::control::currentPresetRoot:
                  {
                      if (msg.find("FAILED") == 1)
                      {
                          if (wasFromHere)
                              fl_alert("%s", msg.c_str());
                      }
                      else
                          readpresetcfg();
                      break;
                  }
                  //case CONFIG::control::enableBankRootChange:
                      //break;
                  case CONFIG::control::bankRootCC:
                      switch (value_int)
                      {
                          case 0:
                              bankrootchange->value(1);
                              break;
                          case 32:
                              bankrootchange->value(0);
                              break;
                          default:
                              bankrootchange->value(2);
                              break;
                      }
                      break;
  
                  case CONFIG::control::bankCC:
                      switch (value_int)
                      {
                          case 0:
                              bankchange->value(1);
                              break;
                          case 32:
                              bankchange->value(0);
                              break;
                          default:
                              bankchange->value(2);
                              break;
                      }
                      break;
                  case CONFIG::control::enableProgramChange:
                      progenable->value(value_bool);
                      break;
                  case CONFIG::control::instChangeEnablesPart:
                      progpartenable->value(value_bool);
                      break;
                  case CONFIG::control::extendedProgramChangeCC:
                      if (value_int > 119)
                      {
                          EPCspinner->value(110);
                          EPCspinner->deactivate();
                          Epcheck->value(0);
                      }
                      else
                      {
                          EPCspinner->value(value_int);
                          EPCspinner->activate();
                          Epcheck->value(1);
                      }
                      break;
                  case CONFIG::control::ignoreResetAllCCs:
                      ignoreReset->value(value_bool);
                      break;
                  case CONFIG::control::logIncomingCCs:
                      midiMon->value(value_bool);
                      break;
                  case CONFIG::control::showLearnEditor:
                      midiLearned->value(value_bool);
                      break;
                  case CONFIG::control::enableNRPNs:
                      enableNRPN->value(value_bool);
                      break;
  
                  case CONFIG::control::saveCurrentConfig:
                      name = msg;
                      if (wasFromHere && name.find("FAILED") == 1)
                          fl_alert("%s",name.c_str());
                      break;
      }
}

ConfigUI::ConfigUI(SynthEngine *_synth) {
  //
              synth = _synth;
              make_window();
              readpresetcfg();
              selectedRootID = -1;
}

void ConfigUI::activatebutton_presetdir(bool active) {
  //
              if (active)
              {
                  removepresetbutton->activate();
                  makedefaultpresetbutton->activate();
              }
              else
              {
                  removepresetbutton->deactivate();
                  makedefaultpresetbutton->deactivate();
              }
}

int ConfigUI::recoverID() {
  //
              if (selectedRootID >= 0)
              {
                  return selectedRootID;
              }
              return 0;
}

void ConfigUI::readpresetcfg() {
  //
              presetbrowse->clear();
              for (int i = 0; i < MAX_PRESET_DIRS; ++i)
                  if (firstSynth->getRuntime().presetsDirlist[i].size())
                  {
                      string name;
                      if (i == synth->getRuntime().currentPreset)
                          name = "* ";
                      else
                          name = "  ";
                      name += firstSynth->getRuntime().presetsDirlist[i];
                      presetbrowse->add(name.c_str());
                  }
}

void ConfigUI::update_config(int tabnumber) {
  //
              int tmp;
              switch (tabnumber)
              {
                  case 1 : // Main
                      osc_size->value( (int)(logf(synth->getRuntime().Oscilsize / 256.0f - 1.0f) / logf(2.0f)) + 1);
                      buff_size->value( (int)(logf(synth->getRuntime().Buffersize / 16.0f - 1.0f) / logf(2.0f)) + 1);
                      pad_interpol->value(synth->getRuntime().Interpolation);
                      v_keyboard->value(synth->getRuntime().VirKeybLayout);
                      compression->value(synth->getRuntime().GzipCompression);
                      reports->value(synth->getRuntime().toConsole);
                      instrument->value(synth->getRuntime().instrumentFormat - 1);
                      break;
  
                  case 2 : // Jack
                      jackSource->value(synth->getRuntime().jackMidiDevice.c_str());
                      if (synth->getRuntime().midiEngine == jack_midi)
                      {
                          jackMidi->value(1);
                          alsaMidi->value(0);
                      }
                      jackServer->value(synth->getRuntime().jackServer.c_str());
                      if (synth->getRuntime().audioEngine == jack_audio)
                      {
                          jackAudio->value(1);
                          alsaAudio->value(0);
                      }
                      break;
  
                  case 3 : // Alsa
                      {
                          alsaSource->value(synth->getRuntime().alsaMidiDevice.c_str());
                          if (synth->getRuntime().midiEngine == alsa_midi)
                          {
                              alsaMidi->value(1);
                              jackMidi->value(0);
                          }
                          alsaDevice->value(synth->getRuntime().alsaAudioDevice.c_str());
                          if (synth->getRuntime().audioEngine == alsa_audio)
                          {
                              alsaAudio->value(1);
                              jackAudio->value(0);
                          }
                          alsaRate->check_none();
                          switch (synth->getRuntime().Samplerate)
                          {
                              case 192000:
                                  alsaRate->set_checked(1);
                                  break;
                              case 96000:
                                  alsaRate->set_checked(2);
                                  break;
                              case 44100:
                                  alsaRate->set_checked(4);
                                  break;
                              case 48000:
                                  alsaRate->set_checked(3);
                                  break;
                          }
                      }
                      break;
  
                  case 4 : // MIDI
                      switch (synth->getRuntime().midi_bank_root)
                      {
                          case 32:
                              bankrootchange->value(0);
                              break;
                          case 0:
                              bankrootchange->value(1);
                              break;
                          default:
                              bankrootchange->value(2);
                              break;
                      }
  
                      switch (synth->getRuntime().midi_bank_C)
                      {
                          case 32:
                              bankchange->value(0);
                              break;
                          case 0:
                              bankchange->value(1);
                              break;
                          default:
                              bankchange->value(2);
                              break;
                      }
                      progenable->value(synth->getRuntime().EnableProgChange);
                      progpartenable->value(synth->getRuntime().enable_part_on_voice_load);
  
                      tmp = synth->getRuntime().midi_upper_voice_C;
                      if (tmp == 128)
                      {
                          EPCspinner->value(110);
                          EPCspinner->deactivate();
                          Epcheck->value(0);
                      }
                      else
                      {
                          EPCspinner->value(tmp);
                          EPCspinner->activate();
                          Epcheck->value(1);
                      }
                      Epend->hide();
                      enableNRPN->value(synth->getRuntime().enable_NRPN);
                      ignoreReset->value(synth->getRuntime().ignoreResetCCs);
                      midiMon->value(synth->getRuntime().monitorCCin);
                      midiLearned->value(synth->getRuntime().showLearnedCC);
                      break;
  
                  case 5 : // Switches
                      setDefaultState->value(synth->getRuntime().loadDefaultState > 0);
                      nonFatal->value(synth->getRuntime().hideErrors);
                      showSplash->value(synth->getRuntime().showSplash);
                      logTimes->value(synth->getRuntime().showTimes);
                      logXML->value(synth->getRuntime().logXMLheaders);
                      saveAllXML->value(synth->getRuntime().xmlmax);
                      enableGUI->value(synth->getRuntime().showGui);
                      enableCLI->value(synth->getRuntime().showCLI);
                      break;
      }
}

void ConfigUI::Show() {
  //
                      if (synth->getIsLV2Plugin() == false && synth->getUniqueId() == 0)
                          singleMaster->show();
                      configwindow->show();
}

void ConfigUI::Hide() {
  //
                      configwindow->hide();
}

string ConfigUI::testCC(int value, int control) {
  //
              CommandBlock getData;
              getData.data.value.F = value;
              getData.data.control = control;
              getData.data.part = 248;
              synth->interchange.testLimits(&getData);
              return textMsgBuffer.fetch(getData.data.miscmsg);
}
