// generated by Fast Light User Interface Designer (fluid) version 1.0305

#include "BankUI.h"
// BankUI.cc

// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2010, Alan Calvert
// Copyright 2014-2019, Will Godfrey & others

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of original ZynAddSubFX code.


#include "MasterUI.h"
#include "Misc/FormatFuncs.h"
    using func::string2int;
    using func::asString;
#include "Misc/TextMsgBuffer.h"

    namespace { // Implementation details...
        TextMsgBuffer& textMsgBuffer = TextMsgBuffer::instance();
    }

void BankProcess_::process(void) {
  ;
}

BankSlot::BankSlot(int x,int y, int w, int h, const char *label):Fl_Button(x,y,w,h,label) {
  //
      what = NULL;
      whatslot = NULL;
      nslot = 0;
      nselected = NULL;
}

int BankSlot::handle(int event) {
  //
      if (what == NULL)
          return 0;
      if (Fl::event_inside(this))
      {
          *what = 0;
          *whatslot = nslot;
          if (event == FL_RELEASE)
              *what = Fl::event_button();
          if (event == FL_PUSH)
              highlight = 1;
      }
      else
          highlight = 0;
      int tmp = Fl_Button::handle(event);
      if (*what != 0 && Fl::event_inside(this))
          (bp->*fnc)();
      return tmp;
}

void BankSlot::init(int nslot_, int *what_, int *whatslot_, void (BankProcess_:: *fnc_)(void), BankProcess_ *bp_, Bank *bank_, int *nselected_) {
  //
          nslot = nslot_;
          what = what_;
          whatslot = whatslot_;
          fnc = fnc_;
          bp = bp_;
          bank = bank_;
          nselected = nselected_;
          box(FL_THIN_UP_FRAME);
          labelfont(0);
          labelsize(13);
          align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE|FL_ALIGN_CLIP);
          highlight = 0;
}

void BankSlot::refresh(int bk, int rt) {
  //
      string instrName = bank->getnamenumbered(nslot, bk, rt);
      copy_label(instrName.c_str());
      rootID = rt;
      bankID = bk;
      if (bank->engines_used(rt, bk, nslot) & 8)
          labelcolor(YOSHI_COLOUR);
      else
          labelcolor(0);
}

/**
 overrides button's draw()
*/
void BankSlot::draw() {
  //
      if (type() == FL_HIDDEN_BUTTON) return;
      int acol, scol, pcol, bcol;
      int wid = w() * 0.334;
      int engine = bank->engines_used(rootID, bankID, nslot);
      if (*nselected == nslot)
      {
          acol = 6;
          scol = 6;
          pcol = 6;
      }
      else if(bank->emptyslot(rootID, bankID, nslot))
      {
          if (nslot < 128)
          {
              acol = 46;
              scol = 46;
              pcol = 46;
          }
          else
          {
              acol = 16;
              scol = 16;
              pcol = 16;
          }
      }
      else
      {
          if (nslot < 128)
              bcol = 51;
          else
              bcol = 17;
          if(engine & 1)
              acol = ADD_COLOUR;
          else
              acol = bcol;
          if(engine & 2)
              scol = SUB_COLOUR;
          else
              scol = bcol;
          if(engine & 4)
              pcol = PAD_COLOUR;
          else
              pcol = bcol;
      }
      draw_box(FL_FLAT_BOX, x(), y(), wid, h(), (Fl_Color) acol);
      draw_box(FL_FLAT_BOX, x() + wid, y(), wid, h(), (Fl_Color) scol);
      draw_box(FL_FLAT_BOX, x() + wid * 2, y(), wid, h(), (Fl_Color) pcol);
  
      //frame for label
      draw_box(value() ? (down_box() ? down_box() : fl_down(box())) : box(), x(), y(), w(), h(), (Fl_Color) BASE_COLOUR);
  
      //draw_backdrop();
  
      Fl_Color col = value() ? selection_color() : color();
      if (labeltype() == FL_NORMAL_LABEL && value())
      {
          Fl_Color c = labelcolor();
          labelcolor(fl_contrast(c, col));
          draw_label();
          labelcolor(c);
      }
      else
          draw_label();
  
      if (Fl::focus() == this) draw_focus();
}

void RootProcess_::rootprocess(void) {
  ;
}

RootSlot::RootSlot(int x,int y, int w, int h, const char *label):Fl_Button(x,y,w,h,label) {
  //
      what = NULL;
      whatslot = NULL;
      nslot = 0;
      nselected = NULL;
}

int RootSlot::handle(int event) {
  //
      if (what == NULL)
          return 0;
      if (Fl::event_inside(this))
      {
          *what = 0;
          *whatslot = nslot;
          if (event == FL_RELEASE)
              *what = Fl::event_button();
          if (event == FL_PUSH)
              highlight = 1;
      }
      else
          highlight = 0;
  
      int tmp = Fl_Button::handle(event);
      if (*what != 0 && Fl::event_inside(this))
          (rp->*fnr)();
      return tmp;
}

void RootSlot::init(int nslot_, int *what_, int *whatslot_, void (RootProcess_:: *fnr_)(void), RootProcess_ *rp_, Bank *root_, int *rselected_) {
  //
  	nslot = nslot_;
          what = what_;
          whatslot = whatslot_;
          fnr = fnr_;
          rp = rp_;
          root = root_;
          rselected = rselected_;
          box(FL_THIN_UP_BOX);
          labelfont(0);
          labelsize(13);
          align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE|FL_ALIGN_CLIP);
          highlight = 0;
          rootrefresh();
}

void RootSlot::rootrefresh() {
  //
          string bankName = root->getBankIDname(nslot);
          if (bankName.empty())
              color(46);
          else if ((unsigned int) nslot == root->getCurrentBankID())
              color(252);
          else
              color(51);
          if (*rselected == nslot)
              color(6);
          copy_label(bankName.c_str());
}

void BankUI::cb_banklist_i(Fl_Choice* o, void*) {
  //
        int n = o->value();
        if (n < 0)
            return;
        const Fl_Menu_Item &item = o->menu()[n];
        int nbank = reinterpret_cast<long>(item.user_data());
        const BankEntry &bankEntry = bank->getBank(nbank);
        if (!bank->setCurrentBankID(nbank))
            fl_alert("Error: Could not load the bank from the directory\n%s.", bankEntry.dirname.c_str());

        int rt = fetchData(0, BANK::control::selectRoot, TOPLEVEL::section::bank);
        int bk = fetchData(0, BANK::control::selectBank, TOPLEVEL::section::bank);
        for (int i = 0; i < BANK_SIZE; ++i)
            bs[i]->refresh(bk, rt);
        refreshmainwindow();
}
void BankUI::cb_banklist(Fl_Choice* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_banklist_i(o,v);
}

void BankUI::cb_B_search_i(Fl_Button*, void*) {
  //
       if (unsearched)
       {
           fillBrowser(1);
           unsearched = false;
       }
       searchwin->show();
}
void BankUI::cb_B_search(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_B_search_i(o,v);
}

void BankUI::cb_Roots_i(Fl_Button*, void*) {
  //
        rootuiwindow->show();
        if ((Fl::event_button() == 3))
        {
            rootFrom = 3;
            instrumentuiwindow->hide();
        }
        instFrom = 0;
}
void BankUI::cb_Roots(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_Roots_i(o,v);
}

void BankUI::cb_Banks_i(Fl_Button*, void*) {
  //
        bankuiwindow->show();
        if ((Fl::event_button() == 3))
        {
            bankFrom = 3;
            instrumentuiwindow->hide();
        }
        instFrom = 0;
}
void BankUI::cb_Banks(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_Banks_i(o,v);
}

void BankUI::cb_writebutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              mode = 2;
          removeselection();
}
void BankUI::cb_writebutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_writebutton_i(o,v);
}

void BankUI::cb_readbutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              mode = 1;
          removeselection();
}
void BankUI::cb_readbutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_readbutton_i(o,v);
}

void BankUI::cb_clearbutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              mode = 3;
          removeselection();
}
void BankUI::cb_clearbutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_clearbutton_i(o,v);
}

void BankUI::cb_swapbutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              mode = 4;
          removeselection();
}
void BankUI::cb_swapbutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_swapbutton_i(o,v);
}

void BankUI::cb_renamebutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              mode = 5;
          removeselection();
}
void BankUI::cb_renamebutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_renamebutton_i(o,v);
}

void BankUI::cb_Close_i(Fl_Button*, void*) {
  //
        if (Fl::event_button() == 3)
        {
            if (instFrom == 2)
            {
                bankFrom = 3;
                bankuiwindow->show();
            }
            else if (instFrom == 4)
            {
                ; // todo open mixer panel
            }
        }
        instFrom = 0; // to avoid later confusion!
        instrumentuiwindow->hide();
}
void BankUI::cb_Close(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void BankUI::cb_enginecheck_i(Fl_Check_Button* o, void*) {
  //
          send_data(TOPLEVEL::action::forceUpdate, CONFIG::control::showEnginesTypes, o->value(), TOPLEVEL::type::Integer, TOPLEVEL::section::config);
}
void BankUI::cb_enginecheck(Fl_Check_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_enginecheck_i(o,v);
}

void BankUI::cb_searchbrowse_i(Fl_Browser* o, void*) {
  //
        if (!o->value())
            return;
        int result = o->value();
        if (result < 0)
            return;
        string line = string(o->text(result));
        int root = string2int(line.substr(0, 3));
        int bank = string2int(line.substr(5, 3));
        int inst = (string2int(line.substr(10, 3))) - 1;
         //std::cout << root << "  " << bank << "  " << inst << std::endl;
         send_data(TOPLEVEL::action::forceUpdate, MAIN::control::loadInstrumentFromBank, inst, TOPLEVEL::type::Integer, TOPLEVEL::section::main, synth->getGuiMaster()->activePart, bank, root);
}
void BankUI::cb_searchbrowse(Fl_Browser* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_searchbrowse_i(o,v);
}

void BankUI::cb_Close1_i(Fl_Button*, void*) {
  //
        searchwin->hide();
}
void BankUI::cb_Close1(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_Close1_i(o,v);
}

void BankUI::cb_searchType_i(Fl_Choice* o, void*) {
  //
          searchbrowse->clear();
          int result = o->value();
          if (result >= 0)
          {
              fillBrowser(result);
              noEntries->hide();
          }
          else
              noEntries->show();
}
void BankUI::cb_searchType(Fl_Choice* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_searchType_i(o,v);
}

Fl_Menu_Item BankUI::menu_searchType[] = {
 {"(undefined)", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Piano", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Chromatic Percussion", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Organ", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Guitar", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Bass", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Solo Strings", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Ensemble", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Brass", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Reed", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Pipe", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Synth Lead", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Synth Pad", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Synth Effects", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Ethnic", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Percussive", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Sound Effects", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {0,0,0,0,0,0,0,0,0}
};

void BankUI::cb_Roots1_i(Fl_Button*, void*) {
  //
        rootuiwindow->show();
        if ((Fl::event_button() == 3))
        {
            rootFrom = 2;
            bankuiwindow->hide();
        }
        else
            rootFrom = 0;
}
void BankUI::cb_Roots1(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_Roots1_i(o,v);
}

void BankUI::cb_Instruments_i(Fl_Button*, void*) {
  //
        instFrom = 2;
        if (synth->getUniqueId() == 0)
        {
            modeselect->show();
            rootmodeselect->show();
        }
        else
        {
            modeselect->hide();
            rootmodeselect->hide();
        }

        instrumentuiwindow->show();
        if (Fl::event_button() == 3)
            bankuiwindow->hide();
}
void BankUI::cb_Instruments(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_Instruments_i(o,v);
}

void BankUI::cb_rootreadbutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              r_mode = 1;
          removeselection();
}
void BankUI::cb_rootreadbutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_rootreadbutton_i(o,v);
}

void BankUI::cb_rootrenamebutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              r_mode = 5;
          removeselection();
}
void BankUI::cb_rootrenamebutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_rootrenamebutton_i(o,v);
}

void BankUI::cb_rootwritebutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              r_mode = 2;
          removeselection();
}
void BankUI::cb_rootwritebutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_rootwritebutton_i(o,v);
}

void BankUI::cb_rootclearbutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              r_mode = 3;
          removeselection();
}
void BankUI::cb_rootclearbutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_rootclearbutton_i(o,v);
}

void BankUI::cb_rootswapbutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              r_mode = 4;
          removeselection();
}
void BankUI::cb_rootswapbutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_rootswapbutton_i(o,v);
}

void BankUI::cb_rootimportbutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              r_mode = 6;
          removeselection();
}
void BankUI::cb_rootimportbutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_rootimportbutton_i(o,v);
}

void BankUI::cb_rootexportbutton_i(Fl_Light_Button* o, void*) {
  //
          if (o->value() > 0.5)
              r_mode = 7;
          removeselection();
}
void BankUI::cb_rootexportbutton(Fl_Light_Button* o, void* v) {
  ((BankUI*)(o->parent()->parent()->user_data()))->cb_rootexportbutton_i(o,v);
}

void BankUI::cb_Close2_i(Fl_Button*, void*) {
  //
            bankuiwindow->hide();
            if (Fl::event_button() == 3)
            {
                if (bankFrom == 1)
                {
                    rootFrom = 2;
                    rootuiwindow->show();
                }
                else if (bankFrom == 3)
                {
                    instFrom = 2;
                    instrumentuiwindow->show();
                }
            }
            else
                bankFrom = 0;
}
void BankUI::cb_Close2(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_Close2_i(o,v);
}

void BankUI::cb_rootuiwindow_i(Fl_Double_Window* o, void*) {
  o->hide();
}
void BankUI::cb_rootuiwindow(Fl_Double_Window* o, void* v) {
  ((BankUI*)(o->user_data()))->cb_rootuiwindow_i(o,v);
}

void BankUI::cb_rootsbrowse_i(Fl_Browser* o, void*) {
  int tmp = o->value();
        activatebutton_rootdir(tmp!=0);
        if (tmp)
        {
            selectedRootID = reinterpret_cast<long>(o->data(tmp));
        }

        changeIDbutton->value(recoverID());
        oldrootID = changeIDbutton->value();
        Pend->hide();
}
void BankUI::cb_rootsbrowse(Fl_Browser* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_rootsbrowse_i(o,v);
}

void BankUI::cb_addrootdirbutton_i(Fl_Button*, void*) {
  //
        const char *dirname;
        dirname = fl_dir_chooser("Add a root directory for banks:", NULL, 0);
        if (!dirname)
            return;
        synth->getBankRef().addRootDir(dirname);
        synth->saveBanks();
        readbankcfg();
        rescan_for_banks(true);
        Pend->hide();
}
void BankUI::cb_addrootdirbutton(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_addrootdirbutton_i(o,v);
}

void BankUI::cb_removerootdirbutton_i(Fl_Button*, void*) {
  //
        if (selectedRootID >= 0)
        {
            synth->getBankRef().removeRoot(selectedRootID);
            synth->saveBanks();
            readbankcfg();
        }
        activatebutton_rootdir(false);
        rescan_for_banks(false);
        Pend->hide();
}
void BankUI::cb_removerootdirbutton(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_removerootdirbutton_i(o,v);
}

void BankUI::cb_makedefaultrootdirbutton_i(Fl_Button*, void*) {
  //
        if (selectedRootID >= 0)
        {
            synth->getBankRef().setCurrentRootID(selectedRootID);
            synth->saveBanks();
            readbankcfg();
            rescan_for_banks(false);
            banklist->value(0);
        }
        activatebutton_rootdir(false);
        Pend->hide();
}
void BankUI::cb_makedefaultrootdirbutton(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_makedefaultrootdirbutton_i(o,v);
}

void BankUI::cb_showdefaultrootdirbutton_i(Fl_Button*, void*) {
  //
        bankuiwindow->show();
        if (Fl::event_button() == 3)
        {
            bankFrom = 1;
            rootuiwindow->hide();
        }
        else
            rootFrom = 0;
}
void BankUI::cb_showdefaultrootdirbutton(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_showdefaultrootdirbutton_i(o,v);
}

void BankUI::cb_Pend_i(Fl_Button* o, void*) {
  //
        int tmp = changeIDbutton->value();
        if (tmp == oldrootID)
        {
            o->hide();
            return;
        }
        if (selectedRootID >= 0)
        {
            synth->getBankRef().changeRootID(selectedRootID, tmp);
            synth->saveBanks();
            readbankcfg();
            rescan_for_banks(true);
        }
        oldrootID = tmp;
        activatebutton_rootdir(false);
        o->hide();
}
void BankUI::cb_Pend(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_Pend_i(o,v);
}

void BankUI::cb_changeIDbutton_i(Fl_Spinner*, void*) {
  Pend->show();
}
void BankUI::cb_changeIDbutton(Fl_Spinner* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_changeIDbutton_i(o,v);
}

void BankUI::cb_Close3_i(Fl_Button*, void*) {
  //
        if (Fl::event_button() == 3)
        {
            if (rootFrom == 2)
            bankuiwindow->show();
        }
        else
            rootFrom = 0;
        rootuiwindow->do_callback();
}
void BankUI::cb_Close3(Fl_Button* o, void* v) {
  ((BankUI*)(o->parent()->user_data()))->cb_Close3_i(o,v);
}

Fl_Double_Window* BankUI::make_window() {
  { instrumentuiwindow = new Fl_Double_Window(780, 575, "Bank");
    instrumentuiwindow->user_data((void*)(this));
    { banklist = new Fl_Choice(5, 8, 199, 20);
      banklist->down_box(FL_BORDER_BOX);
      banklist->selection_color(FL_BACKGROUND2_COLOR);
      banklist->labelfont(1);
      banklist->labelsize(12);
      banklist->textsize(12);
      banklist->callback((Fl_Callback*)cb_banklist);
      banklist->align(Fl_Align(FL_ALIGN_CENTER));
    } // Fl_Choice* banklist
    { B_search = new Fl_Button(230, 5, 93, 25, "Search");
      B_search->tooltip("Select instrument from list, by type");
      B_search->box(FL_PLASTIC_UP_BOX);
      B_search->labelfont(1);
      B_search->labelsize(11);
      B_search->callback((Fl_Callback*)cb_B_search);
      B_search->align(Fl_Align(FL_ALIGN_WRAP));
    } // Fl_Button* B_search
    { Fl_Button* o = new Fl_Button(350, 5, 93, 25, "Roots");
      o->tooltip("Show root paths. Right click: also close this");
      o->box(FL_PLASTIC_UP_BOX);
      o->labelfont(1);
      o->labelsize(11);
      o->callback((Fl_Callback*)cb_Roots);
      o->align(Fl_Align(FL_ALIGN_WRAP));
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(496, 5, 93, 25, "Banks");
      o->tooltip("Show banks in current root. Right click: also close this");
      o->box(FL_PLASTIC_UP_BOX);
      o->labelfont(1);
      o->labelsize(11);
      o->callback((Fl_Callback*)cb_Banks);
      o->align(Fl_Align(FL_ALIGN_WRAP));
    } // Fl_Button* o
    { Fl_Text_Display* o = new Fl_Text_Display(628, 17, 136, 3, "This column uses MIDI");
      o->box(FL_NO_BOX);
      o->labelsize(11);
      o->align(Fl_Align(33));
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(615, 30, 162, 3, "Extended Program Change");
      o->box(FL_NO_BOX);
      o->labelsize(11);
      o->align(Fl_Align(33));
    } // Fl_Text_Display* o
    { Fl_Group* o = new Fl_Group(5, 34, 772, 491);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Pack* o = new Fl_Pack(10, 39, 150, 481);
        o->box(FL_BORDER_BOX);
        o->box(FL_NO_BOX);
        for (int i = 0; i < 32; ++i)
            {
                bs[i] = new BankSlot (0, 0, o->w(), 15, " ");
                bs[i]->init(i, &what, &slot, &BankProcess_::process,
                            (BankProcess_ *)this, bank, &nselected);
            }
        o->end();
      } // Fl_Pack* o
      { Fl_Pack* o = new Fl_Pack(163, 39, 150, 481);
        o->box(FL_BORDER_BOX);
        o->box(FL_NO_BOX);
        for (int i = 32; i < 64; ++i)
            {
                bs[i] = new BankSlot (0, 0, o->w(), 15, " ");
                bs[i]->init(i, &what, &slot, &BankProcess_::process,
                            (BankProcess_ *)this, bank, &nselected);
            }
        o->end();
      } // Fl_Pack* o
      { Fl_Pack* o = new Fl_Pack(316, 39, 150, 481);
        o->box(FL_BORDER_BOX);
        o->box(FL_NO_BOX);
        for (int i = 64; i < 96; ++i)
            {
                bs[i] = new BankSlot (0, 0, o->w(), 15, " ");
                bs[i]->init(i, &what, &slot, &BankProcess_::process,
                            (BankProcess_ *)this, bank, &nselected);
            }
        o->end();
      } // Fl_Pack* o
      { Fl_Pack* o = new Fl_Pack(469, 39, 150, 481);
        o->box(FL_BORDER_BOX);
        o->box(FL_NO_BOX);
        for (int i = 96; i < 128; ++i)
            {
                bs[i] = new BankSlot (0, 0, o->w(), 15, " ");
                bs[i]->init(i, &what, &slot, &BankProcess_::process,
                            (BankProcess_ *)this, bank, &nselected);
            }
        o->end();
      } // Fl_Pack* o
      { Fl_Pack* o = new Fl_Pack(622, 39, 150, 481);
        o->box(FL_BORDER_BOX);
        o->color((Fl_Color)48);
        o->box(FL_NO_BOX);
        for (int i = 128; i < 160; ++i)
            {
                bs[i] = new BankSlot (0, 0, o->w(), 15, " ");
                bs[i]->init(i, &what, &slot, &BankProcess_::process,
                            (BankProcess_ *)this, bank, &nselected);
            }
        o->end();
      } // Fl_Pack* o
      o->end();
    } // Fl_Group* o
    { modeselect = new Fl_Group(5, 528, 458, 42);
      modeselect->box(FL_ENGRAVED_BOX);
      modeselect->hide();
      { writebutton = new Fl_Light_Button(190, 534, 85, 30, "SAVE");
        writebutton->type(102);
        writebutton->box(FL_PLASTIC_UP_BOX);
        writebutton->down_box(FL_THIN_DOWN_BOX);
        writebutton->selection_color((Fl_Color)3);
        writebutton->labelfont(9);
        writebutton->labelsize(12);
        writebutton->callback((Fl_Callback*)cb_writebutton);
      } // Fl_Light_Button* writebutton
      { Fl_Light_Button* o = readbutton = new Fl_Light_Button(10, 534, 85, 30, "SELECT");
        readbutton->type(102);
        readbutton->box(FL_PLASTIC_UP_BOX);
        readbutton->down_box(FL_THIN_DOWN_BOX);
        readbutton->selection_color((Fl_Color)101);
        readbutton->labelfont(9);
        readbutton->labelsize(12);
        readbutton->callback((Fl_Callback*)cb_readbutton);
        o->value(1);
      } // Fl_Light_Button* readbutton
      { clearbutton = new Fl_Light_Button(280, 534, 85, 30, "DELETE");
        clearbutton->type(102);
        clearbutton->box(FL_PLASTIC_UP_BOX);
        clearbutton->down_box(FL_THIN_DOWN_BOX);
        clearbutton->selection_color((Fl_Color)1);
        clearbutton->labelfont(9);
        clearbutton->labelsize(12);
        clearbutton->callback((Fl_Callback*)cb_clearbutton);
      } // Fl_Light_Button* clearbutton
      { swapbutton = new Fl_Light_Button(370, 534, 85, 30, "SWAP");
        swapbutton->type(102);
        swapbutton->box(FL_PLASTIC_UP_BOX);
        swapbutton->down_box(FL_THIN_DOWN_BOX);
        swapbutton->selection_color((Fl_Color)227);
        swapbutton->labelfont(9);
        swapbutton->labelsize(12);
        swapbutton->callback((Fl_Callback*)cb_swapbutton);
      } // Fl_Light_Button* swapbutton
      { renamebutton = new Fl_Light_Button(100, 534, 85, 30, "RENAME");
        renamebutton->type(102);
        renamebutton->box(FL_PLASTIC_UP_BOX);
        renamebutton->down_box(FL_THIN_DOWN_BOX);
        renamebutton->selection_color((Fl_Color)5);
        renamebutton->labelfont(9);
        renamebutton->labelsize(12);
        renamebutton->callback((Fl_Callback*)cb_renamebutton);
      } // Fl_Light_Button* renamebutton
      modeselect->end();
    } // Fl_Group* modeselect
    { Fl_Button* o = new Fl_Button(665, 539, 70, 24, "Close");
      o->tooltip("Right click: also reopen previous");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close);
    } // Fl_Button* o
    { Fl_Group* o = new Fl_Group(468, 528, 151, 42);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Check_Button* o = enginecheck = new Fl_Check_Button(477, 531, 136, 15, "Show engines/types");
        enginecheck->down_box(FL_DOWN_BOX);
        enginecheck->labelsize(11);
        enginecheck->callback((Fl_Callback*)cb_enginecheck);
        o->value(synth->getRuntime().checksynthengines);
      } // Fl_Check_Button* enginecheck
      { Fl_Button* o = addpatch = new Fl_Button(473, 550, 47, 16, "Add");
        addpatch->box(FL_FLAT_BOX);
        addpatch->labelsize(12);
        addpatch->align(Fl_Align(FL_ALIGN_TEXT_OVER_IMAGE));
        o->color(ADD_COLOUR);
      } // Fl_Button* addpatch
      { Fl_Button* o = subpatch = new Fl_Button(520, 550, 47, 16, "Sub");
        subpatch->box(FL_FLAT_BOX);
        subpatch->labelsize(11);
        subpatch->align(Fl_Align(FL_ALIGN_TEXT_OVER_IMAGE));
        o->color(SUB_COLOUR);
      } // Fl_Button* subpatch
      { Fl_Button* o = padpatch = new Fl_Button(567, 550, 47, 16, "Pad");
        padpatch->box(FL_FLAT_BOX);
        padpatch->color((Fl_Color)29);
        padpatch->labelsize(12);
        padpatch->align(Fl_Align(FL_ALIGN_TEXT_OVER_IMAGE));
        o->color(PAD_COLOUR);
      } // Fl_Button* padpatch
      { Fl_Button* o = new Fl_Button(474, 549, 139, 17);
        o->box(FL_THIN_UP_FRAME);
      } // Fl_Button* o
      o->end();
    } // Fl_Group* o
    instrumentuiwindow->end();
  } // Fl_Double_Window* instrumentuiwindow
  { searchwin = new Fl_Double_Window(305, 490, "Bank Search");
    searchwin->box(FL_PLASTIC_THIN_UP_BOX);
    searchwin->color((Fl_Color)22);
    searchwin->user_data((void*)(this));
    { searchbrowse = new Fl_Browser(12, 65, 282, 374);
      searchbrowse->type(1);
      searchbrowse->labelfont(4);
      searchbrowse->callback((Fl_Callback*)cb_searchbrowse);
    } // Fl_Browser* searchbrowse
    { Fl_Button* o = new Fl_Button(228, 451, 65, 24, "Close");
      o->callback((Fl_Callback*)cb_Close1);
      o->align(Fl_Align(192));
    } // Fl_Button* o
    { Fl_Group* o = new Fl_Group(25, 1, 210, 35);
      { searchType = new Fl_Choice(70, 12, 140, 24, "Type:");
        searchType->down_box(FL_BORDER_BOX);
        searchType->labelfont(1);
        searchType->labelsize(12);
        searchType->textsize(12);
        searchType->callback((Fl_Callback*)cb_searchType);
        searchType->menu(menu_searchType);
      } // Fl_Choice* searchType
      o->end();
    } // Fl_Group* o
    { Fl_Text_Display* o = new Fl_Text_Display(1, 34, 50, 12, "Root");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM));
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(40, 34, 50, 12, "Bank");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM));
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(100, 35, 50, 12, "Instrument");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM));
    } // Fl_Text_Display* o
    { noEntries = new Fl_Text_Display(70, 195, 177, 0, "No Entries");
      noEntries->labelfont(1);
      noEntries->labelsize(30);
      noEntries->labelcolor(FL_RED);
      noEntries->hide();
      noEntries->deactivate();
    } // Fl_Text_Display* noEntries
    searchwin->set_modal();
    searchwin->end();
  } // Fl_Double_Window* searchwin
  { Fl_Double_Window* o = bankuiwindow = new Fl_Double_Window(775, 575, "Root");
    bankuiwindow->labelsize(12);
    bankuiwindow->user_data((void*)(this));
    { Fl_Button* o = new Fl_Button(248, 5, 93, 25, "Roots");
      o->tooltip("Show root paths. Right click: also close this");
      o->box(FL_PLASTIC_UP_BOX);
      o->labelfont(1);
      o->labelsize(11);
      o->callback((Fl_Callback*)cb_Roots1);
      o->align(Fl_Align(FL_ALIGN_WRAP));
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(394, 10, 178, 15, "current bank");
      o->tooltip("Show instruments in current bank");
      o->box(FL_THIN_UP_BOX);
      o->down_box(FL_THIN_UP_BOX);
      o->color((Fl_Color)252);
      o->selection_color((Fl_Color)252);
      o->labelsize(12);
      o->align(Fl_Align(FL_ALIGN_WRAP));
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(627, 5, 93, 25, "Instruments");
      o->tooltip("Show instruments in current bank. Right click: also close this");
      o->box(FL_PLASTIC_UP_BOX);
      o->labelfont(1);
      o->labelsize(11);
      o->callback((Fl_Callback*)cb_Instruments);
      o->align(Fl_Align(FL_ALIGN_WRAP));
    } // Fl_Button* o
    { Fl_Group* o = new Fl_Group(5, 34, 766, 491);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Pack* o = new Fl_Pack(10, 39, 186, 481);
        o->box(FL_BORDER_BOX);
        o->box(FL_NO_BOX);
        //
            for (int i = 0; i < 32; ++i)
            {
                rs[i] = new RootSlot (0, 0, o->w(), 15, " ");
                rs[i]->init(i, &what, &slot, &RootProcess_::rootprocess,
                            (RootProcess_ *)this, bank, &rselected);

          }
        o->end();
      } // Fl_Pack* o
      { Fl_Pack* o = new Fl_Pack(200, 39, 186, 481);
        o->box(FL_BORDER_BOX);
        o->box(FL_NO_BOX);
        //
            for (int i = 32; i < 64; ++i)
            {
                rs[i] = new RootSlot (0, 0, o->w(), 15, " ");
                rs[i]->init(i, &what, &slot, &RootProcess_::rootprocess,
                            (RootProcess_ *)this, bank, &rselected);

          }
        o->end();
      } // Fl_Pack* o
      { Fl_Pack* o = new Fl_Pack(390, 39, 186, 481);
        o->box(FL_BORDER_BOX);
        o->box(FL_NO_BOX);
        //
            for (int i = 64; i < 96; ++i)
            {
                rs[i] = new RootSlot (0, 0, o->w(), 15, " ");
                rs[i]->init(i, &what, &slot, &RootProcess_::rootprocess,
                            (RootProcess_ *)this, bank, &rselected);

          }
        o->end();
      } // Fl_Pack* o
      { Fl_Pack* o = new Fl_Pack(580, 39, 185, 481);
        o->box(FL_BORDER_BOX);
        o->box(FL_NO_BOX);
        //
            for (int i = 96; i < 128; ++i)
            {
                rs[i] = new RootSlot (0, 0, o->w(), 15, " ");
                rs[i]->init(i, &what, &slot, &RootProcess_::rootprocess,
                            (RootProcess_ *)this, bank, &rselected);

          }
        o->end();
      } // Fl_Pack* o
      o->end();
    } // Fl_Group* o
    { rootmodeselect = new Fl_Group(5, 528, 570, 42);
      rootmodeselect->box(FL_ENGRAVED_BOX);
      rootmodeselect->hide();
      { Fl_Light_Button* o = rootreadbutton = new Fl_Light_Button(10, 534, 85, 30, "SELECT");
        rootreadbutton->type(102);
        rootreadbutton->box(FL_PLASTIC_UP_BOX);
        rootreadbutton->down_box(FL_THIN_DOWN_BOX);
        rootreadbutton->selection_color((Fl_Color)101);
        rootreadbutton->labelfont(9);
        rootreadbutton->labelsize(12);
        rootreadbutton->callback((Fl_Callback*)cb_rootreadbutton);
        o->value(1);
      } // Fl_Light_Button* rootreadbutton
      { rootrenamebutton = new Fl_Light_Button(105, 534, 85, 30, "RENAME");
        rootrenamebutton->type(102);
        rootrenamebutton->box(FL_PLASTIC_UP_BOX);
        rootrenamebutton->down_box(FL_THIN_DOWN_BOX);
        rootrenamebutton->selection_color((Fl_Color)5);
        rootrenamebutton->labelfont(9);
        rootrenamebutton->labelsize(12);
        rootrenamebutton->callback((Fl_Callback*)cb_rootrenamebutton);
      } // Fl_Light_Button* rootrenamebutton
      { rootwritebutton = new Fl_Light_Button(200, 534, 85, 30, "ADD");
        rootwritebutton->type(102);
        rootwritebutton->box(FL_PLASTIC_UP_BOX);
        rootwritebutton->down_box(FL_THIN_DOWN_BOX);
        rootwritebutton->selection_color((Fl_Color)3);
        rootwritebutton->labelfont(9);
        rootwritebutton->labelsize(12);
        rootwritebutton->callback((Fl_Callback*)cb_rootwritebutton);
      } // Fl_Light_Button* rootwritebutton
      { rootclearbutton = new Fl_Light_Button(295, 534, 85, 30, "DELETE");
        rootclearbutton->type(102);
        rootclearbutton->box(FL_PLASTIC_UP_BOX);
        rootclearbutton->down_box(FL_THIN_DOWN_BOX);
        rootclearbutton->selection_color((Fl_Color)1);
        rootclearbutton->labelfont(9);
        rootclearbutton->labelsize(12);
        rootclearbutton->callback((Fl_Callback*)cb_rootclearbutton);
      } // Fl_Light_Button* rootclearbutton
      { rootswapbutton = new Fl_Light_Button(390, 534, 85, 30, "SWAP");
        rootswapbutton->type(102);
        rootswapbutton->box(FL_PLASTIC_UP_BOX);
        rootswapbutton->down_box(FL_THIN_DOWN_BOX);
        rootswapbutton->selection_color((Fl_Color)227);
        rootswapbutton->labelfont(9);
        rootswapbutton->labelsize(12);
        rootswapbutton->callback((Fl_Callback*)cb_rootswapbutton);
      } // Fl_Light_Button* rootswapbutton
      { rootimportbutton = new Fl_Light_Button(485, 533, 85, 15, "IMPORT");
        rootimportbutton->type(102);
        rootimportbutton->box(FL_PLASTIC_UP_BOX);
        rootimportbutton->down_box(FL_THIN_DOWN_BOX);
        rootimportbutton->selection_color((Fl_Color)93);
        rootimportbutton->labelfont(8);
        rootimportbutton->labelsize(9);
        rootimportbutton->callback((Fl_Callback*)cb_rootimportbutton);
      } // Fl_Light_Button* rootimportbutton
      { rootexportbutton = new Fl_Light_Button(485, 550, 85, 15, "EXPORT");
        rootexportbutton->type(102);
        rootexportbutton->box(FL_PLASTIC_UP_BOX);
        rootexportbutton->down_box(FL_THIN_DOWN_BOX);
        rootexportbutton->selection_color((Fl_Color)78);
        rootexportbutton->labelfont(8);
        rootexportbutton->labelsize(9);
        rootexportbutton->callback((Fl_Callback*)cb_rootexportbutton);
      } // Fl_Light_Button* rootexportbutton
      rootmodeselect->end();
    } // Fl_Group* rootmodeselect
    { Fl_Button* o = new Fl_Button(647, 538, 70, 24, "Close");
      o->tooltip("Right click: also reopen previous");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close2);
    } // Fl_Button* o
    o->copy_label(bank->getRootFileTitle(fetchData(0, BANK::control::selectRoot, TOPLEVEL::section::bank)).c_str());
    if (synth->getUniqueId() == 0) rootmodeselect->show();
    bankuiwindow->end();
  } // Fl_Double_Window* bankuiwindow
  { Fl_Double_Window* o = rootuiwindow = new Fl_Double_Window(465, 295, "Bank Root Paths");
    rootuiwindow->callback((Fl_Callback*)cb_rootuiwindow, (void*)(this));
    { rootsbrowse = new Fl_Browser(10, 10, 445, 200);
      rootsbrowse->type(2);
      rootsbrowse->labelsize(12);
      rootsbrowse->textsize(13);
      rootsbrowse->callback((Fl_Callback*)cb_rootsbrowse);
    } // Fl_Browser* rootsbrowse
    { addrootdirbutton = new Fl_Button(10, 225, 75, 35, "Add root directory...");
      addrootdirbutton->box(FL_THIN_UP_BOX);
      addrootdirbutton->labelsize(12);
      addrootdirbutton->callback((Fl_Callback*)cb_addrootdirbutton);
      addrootdirbutton->align(Fl_Align(FL_ALIGN_WRAP));
      addrootdirbutton->hide();
    } // Fl_Button* addrootdirbutton
    { Fl_Button* o = removerootdirbutton = new Fl_Button(95, 225, 75, 35, "Remove root dir...");
      removerootdirbutton->box(FL_THIN_UP_BOX);
      removerootdirbutton->labelsize(12);
      removerootdirbutton->callback((Fl_Callback*)cb_removerootdirbutton);
      removerootdirbutton->align(Fl_Align(FL_ALIGN_WRAP));
      removerootdirbutton->hide();
      removerootdirbutton->deactivate();
      o->deactivate();
    } // Fl_Button* removerootdirbutton
    { Fl_Button* o = makedefaultrootdirbutton = new Fl_Button(180, 225, 75, 35, "Make current");
      makedefaultrootdirbutton->box(FL_THIN_UP_BOX);
      makedefaultrootdirbutton->labelsize(12);
      makedefaultrootdirbutton->callback((Fl_Callback*)cb_makedefaultrootdirbutton);
      makedefaultrootdirbutton->align(Fl_Align(FL_ALIGN_WRAP));
      makedefaultrootdirbutton->deactivate();
      o->deactivate();
    } // Fl_Button* makedefaultrootdirbutton
    { showdefaultrootdirbutton = new Fl_Button(265, 225, 75, 35, "Open current");
      showdefaultrootdirbutton->tooltip("Right click: also close this");
      showdefaultrootdirbutton->box(FL_THIN_UP_BOX);
      showdefaultrootdirbutton->labelsize(12);
      showdefaultrootdirbutton->callback((Fl_Callback*)cb_showdefaultrootdirbutton);
      showdefaultrootdirbutton->align(Fl_Align(FL_ALIGN_WRAP));
    } // Fl_Button* showdefaultrootdirbutton
    { Pend = new Fl_Button(400, 239, 56, 18, "Pending");
      Pend->tooltip("Click to set");
      Pend->box(FL_PLASTIC_UP_BOX);
      Pend->color((Fl_Color)90);
      Pend->labelsize(10);
      Pend->callback((Fl_Callback*)cb_Pend);
      Pend->hide();
    } // Fl_Button* Pend
    { Fl_Spinner* o = changeIDbutton = new Fl_Spinner(348, 238, 45, 19, "Change ID");
      changeIDbutton->labelsize(12);
      changeIDbutton->minimum(0);
      changeIDbutton->maximum(126);
      changeIDbutton->textsize(12);
      changeIDbutton->callback((Fl_Callback*)cb_changeIDbutton);
      changeIDbutton->align(Fl_Align(FL_ALIGN_TOP_LEFT));
      changeIDbutton->hide();
      changeIDbutton->deactivate();
      oldrootID = o->value();
    } // Fl_Spinner* changeIDbutton
    { Fl_Button* o = new Fl_Button(402, 268, 51, 20, "Close");
      o->tooltip("Right click: also reopen previous");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close3);
    } // Fl_Button* o
    readbankcfg();
    o->copy_label(synth->makeUniqueName("Bank Root Paths").c_str());
    if (synth->getUniqueId() == 0) {addrootdirbutton->show();  removerootdirbutton->show();  changeIDbutton->show();}
    rootuiwindow->end();
  } // Fl_Double_Window* rootuiwindow
  return rootuiwindow;
}

void BankUI::fillBrowser(int group) {
  //
           /* for (int root = 0; root < 128; ++root)
            {
                for (int bank = 0; bank < 128; ++ bank)
                {
                    for (int inst = 0; inst < 160; ++ inst)
                    {
                        int ID = synth->getBankRef().getType(inst, bank, root);
                        if (ID == group)
                        {
                            //string line = asString(root, 3) + ": " + asString(bank, 3) + ". " + asString(inst + 1, 3) + "  " + synth->getBankRef().getname(inst, bank, root);
                            searchbrowse->add(line.c_str());
                        }
                    }
                }
            }*/
            string line;
            do
            {
                line = textMsgBuffer.fetch(fetchData(0, BANK::control::findInstrumentName, TOPLEVEL::section::bank, UNUSED, UNUSED, UNUSED, group));
                if (line !="*")
                    searchbrowse->add(line.c_str());
            } while (line != "*");
}

void BankUI::send_data(int action, int control, float value, int type, int part , int kititem , int engine , int insert , int parameter , int miscmsg ) {
  //
          type |= TOPLEVEL::type::Write;
          collect_data(synth, value, action, type, control, part, kititem, engine, insert, parameter, UNUSED, miscmsg);
}

float BankUI::fetchData(float value, int control, int part, int kititem , int engine , int insert , int parameter , int offset , int miscmsg , int request ) {
  //
          return collect_readData(synth, value, control, part, kititem, engine, insert, parameter, offset, miscmsg, request);
}

void BankUI::returns_update(CommandBlock *getData) {
  //
      //int value_int = getData->data.value.F;
      unsigned char control = getData->data.control;
      int source = getData->data.source & TOPLEVEL::action::noAction;
      string message = textMsgBuffer.fetch(getData->data.miscmsg);
      switch(control)
      {
          case BANK::control::exportBank:
              if(source == TOPLEVEL::action::fromGUI)
                  fl_alert("%s",message.c_str());
          break;
          case BANK::control::deleteInstrument:
              if (message.find("FAILED") != std::string::npos)
              {
                  if(source == TOPLEVEL::action::fromGUI)
                      fl_alert("%s",message.c_str());
              }
              else
                  rescan_for_banks(false);
              break;
          case BANK::control::selectFirstInstrumentToSwap:
              break;
          case BANK::control::selectSecondInstrumentAndSwap:
  
              if (message.find("FAILED") != std::string::npos)
                  if(source == TOPLEVEL::action::fromGUI)
                      fl_alert("%s",message.c_str());
              rescan_for_banks(false);
              break;
  
          case BANK::control::selectFirstBankToSwap:
              break;
          case BANK::control::selectSecondBankAndSwap:
              if (message.find("FAILED") != std::string::npos)
                  if(source == TOPLEVEL::action::fromGUI)
                      fl_alert("%s",message.c_str());
              rescan_for_banks(false);
              break;
      }
}

BankUI::BankUI(SynthEngine *_synth) {
  //
      synth = _synth;
      fnc = &BankProcess_::process;
      bank = synth->getBankPtr();
      what = 0;
      nselected = -1;
      rselected = -1;
      make_window();
      mode = 1;
      r_mode = 1;
      fnr = &RootProcess_::rootprocess;
      root = synth->getBankPtr();
      rootFrom = 0;
      bankFrom = 0;
      instFrom = 0;
}

BankUI::~BankUI() {
  //
          instrumentuiwindow->hide();
          delete instrumentuiwindow;
          bankuiwindow->hide();
          delete bankuiwindow;
          rootuiwindow->hide();
          delete rootuiwindow;
}

void BankUI::Show() {
  // called from part UI
      rescan_for_banks(false);
      set_bank_slot();
      instrumentuiwindow->show();
      readbutton->value(1);
      mode = 1;
      removeselection();
      if (synth->getUniqueId() == 0)
      {
          modeselect->show();
          rootmodeselect->show();
      }
      else
      {
          modeselect->hide();
          rootmodeselect->hide();
      }
      refreshmainwindow();
}

void BankUI::Hide() {
  // called from master UI
      instrumentuiwindow->hide();
}

void BankUI::init(Fl_Spinner *cbwig_) {
  //
      cbwig = cbwig_;
      rescan_for_banks(false);
      unsearched = true;
      searchType->value(1);
      if(synth->getRuntime().checksynthengines)
          B_search->activate();
      else
          B_search->deactivate();
}

void BankUI::process() {
  //
          int slot = this->slot;
          int curPart = synth->getRuntime().currentPart;
          int rt = fetchData(0, BANK::control::selectRoot, TOPLEVEL::section::bank);
          int bk = fetchData(0, BANK::control::selectBank, TOPLEVEL::section::bank);
          bool slotFilled = !bank->emptyslot(rt, bk, slot);
          string thisname =  bank->getname(slot, bk, rt);
          if ((what == 1 || what == 3) && mode == 1 && slotFilled)
          {
              if (synth->getGuiMaster()->activePart == UNUSED)
              {
                  fl_alert("Active part disabled");
                  return;
              }
              send_data(TOPLEVEL::action::forceUpdate, MAIN::control::loadInstrumentFromBank, slot, TOPLEVEL::type::Integer, TOPLEVEL::section::main,synth->getGuiMaster()->activePart);
              // Reads from slot
              if (what == 3)
                  instrumentuiwindow->hide();
              return;
          }
  
          if (mode == 5 && slotFilled)
          {   // Rename slot
              const char *newname = fl_input("Instrument name:", thisname.c_str());
              if (newname)
              {
                  if (string(newname) == "Simple Sound")
                      fl_alert("Can't use name of default sound");
                  else if (strlen(newname) > 3)
                  {
                      if (!bank->setname(slot, string(newname), slot, bk, bk, rt, rt))
                      {
                          setread();
                          fl_alert("Could not rename instrument %d to %s", slot, newname);
                      }
                      else
                      {
                          synth->part[curPart]->Pname = newname;
                          send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate, MAIN::control::saveInstrument, float(synth->getGuiMaster()->activePart), TOPLEVEL::type::Integer, TOPLEVEL::section::main, UNUSED, UNUSED, slot);
                      }
                  }
              }
              setread();
              cbwig->do_callback();
          }
  
          if (mode == 2)
          {   // save(write) to slot (choices reversed for 'No' priority)
              bool doit = true;
              if (synth->part[curPart]->Pname == "Simple Sound")
              {
                  fl_alert("Can't store instrument with default name");
                  setread();
                  doit = false;
              }
              else if (slotFilled)
              {
                  if (fl_choice("Overwrite the slot no. %d ?", NULL, "No", "Yes", slot + 1) < 2)
                  {
                      setread();
                      doit = false;
                  }
              }
              if (doit)
              {
                  send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate, MAIN::control::saveInstrument, float(curPart), TOPLEVEL::type::Integer, TOPLEVEL::section::main, UNUSED, UNUSED, slot);
                  setread();
              }
          }
  
          if (mode == 3 && slotFilled)
          {   // Clears the slot (choices reversed for 'No' priority)
              if (fl_choice("Clear the slot no. %d ?", NULL, "No", "Yes", slot + 1) > 1)
                  send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate, BANK::control::deleteInstrument, slot, TOPLEVEL::type::Write, TOPLEVEL::section::bank);
              setread();
          }
  
          if (mode == 4)
          {   // swap
              bool done = false;
              if (what == 1 && nselected >= 0)
              {
                  send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate, BANK::control::selectSecondInstrumentAndSwap, 0, TOPLEVEL::type::Integer, TOPLEVEL::section::bank, UNUSED, UNUSED, slot);
                  nselected = -1;
                  setread();
                  done = true;
              }
              if ((nselected < 0 || what == 2) && !done)
              {
                  send_data(TOPLEVEL::action::lowPrio, BANK::control::selectFirstInstrumentToSwap, 0, TOPLEVEL::type::Integer, TOPLEVEL::section::bank, UNUSED, UNUSED, slot);
                  nselected = slot;
              }
          }
          if (mode != 4)
              refreshmainwindow();
}

void BankUI::rootprocess() {
  //
      unsigned int slot = this->slot;
      int rt = fetchData(0, BANK::control::selectRoot, TOPLEVEL::section::bank);
      string thisname = bank->getBankName(slot, rt);
  
      if ((what == 1 || what == 3) && r_mode == 1 && !thisname.empty())
      {
          // Selects from slot
          const BankEntry &bankEntry = bank->getBank(slot, rt);
  
          if (!bank->setCurrentBankID(slot))
          {
              fl_alert("Error: Could not load the bank from the directory\n%s.",
                      bankEntry.dirname.c_str());
              setrootread();
              return;
          }
          instFrom = 2;
          if (what == 3)
              bankuiwindow->hide();
  
          cbwig->do_callback();
          if (synth->getUniqueId() == 0)
          {
              modeselect->show();
              rootmodeselect->show();
          }
          else
          {
              modeselect->hide();
              rootmodeselect->hide();
          }
          instrumentuiwindow->show();
          set_bank_slot(); // needed by 'old' menu selector
          refreshmainwindow();
          return;
      }
  
      if (r_mode == 7)
      {
      	const char *dirname;
          dirname = fl_dir_chooser("Export a bank:",synth->getRuntime().userHome.c_str(), 0);
          if (dirname)
              send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate, MAIN::control::exportBank, slot, TOPLEVEL::type::Integer, TOPLEVEL::section::main, UNUSED, UNUSED, UNUSED, UNUSED, textMsgBuffer.push(string(dirname)));
     	setrootread();
      }
  
      if (r_mode == 6)
      {
      	const char *dirname;
          dirname = fl_dir_chooser("Import a new bank:",synth->getRuntime().userHome.c_str(), 0);
          if (dirname)
              send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate, MAIN::control::importBank, slot, TOPLEVEL::type::Integer, TOPLEVEL::section::main, UNUSED, UNUSED, UNUSED, UNUSED, textMsgBuffer.push(string(dirname)));
     	setrootread();
      }
  
      if (r_mode == 5 && !thisname.empty())
      {   // Rename bank
          const char *tmp = fl_input("Bank name:",thisname.c_str());
          if (tmp)
              if (strlen(tmp) > 2) // insist on a readable name
              {
                  if (!bank->setbankname(slot, string(tmp)))
                  {
                      setrootread();
                      fl_alert("Cound not rename bank %d to %s", slot, thisname.c_str());
                      return;
                  }
                  else
                  {
                      rs[slot]->rootrefresh();
                      rescan_for_banks(false);
                      set_bank_slot();
                  }
              }
          setrootread();
      }
  
      if (r_mode == 2)
      {   // Create new bank and save to file
          if (!thisname.empty())
          {
              setrootread();
              fl_alert("Bank %d already in use for %s", slot, thisname.c_str());
              return;
          }
          const char *dirname;
          dirname = fl_input("New empty Bank:");
          if (dirname == NULL)
          {
              setrootread();
              return;
          }
  
          if (!bank->newIDbank(dirname, (unsigned int)slot))
          {
              setrootread();
              fl_alert("Could not make a new bank directory.");
              return;
          }
          bank->setCurrentBankID(slot);
          rs[slot]->rootrefresh();
          rescan_for_banks(false);
          set_bank_slot();
          setrootread();
          refreshmainwindow();
      }
  
      if (r_mode == 3 && !thisname.empty())
      {   // Remove bank and file contents (choices reversed for 'No' priority)
          if (fl_choice("Completely remove %s?", NULL, "No", "Yes", thisname.c_str()) > 1)
          {
              int clearit = true;
              int count = bank->getBankSize(slot);
              if (count > 1)
                  clearit = fl_choice("There are %d instruments in this bank\nThey will be permanently deleted",
                                      NULL, "STOP !", "Continue", count) > 1;
              if (clearit)
              {
                  send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate, MAIN::control::deleteBank, slot, TOPLEVEL::type::Integer, TOPLEVEL::section::main);
              }
          }
          setrootread();
          refreshmainwindow();
      }
  
      if (r_mode == 4)
      {   // Swap banks
  
              bool done = false;
              if (what == 1 && rselected >= 0)
              {
                  send_data(TOPLEVEL::action::lowPrio | TOPLEVEL::action::forceUpdate, BANK::control::selectSecondBankAndSwap, 0, TOPLEVEL::type::Integer, TOPLEVEL::section::bank, slot);
                  rselected = -1;
                  rescan_for_banks(false);
                  setrootread();
                  done = true;
              }
              if ((rselected < 0 || what == 2) && !done)
              {
                  send_data(TOPLEVEL::action::lowPrio, BANK::control::selectFirstBankToSwap, 0, TOPLEVEL::type::Integer, TOPLEVEL::section::bank, slot);
                  rselected = slot;
                  rs[slot]->rootrefresh();
              }
      }
}

void BankUI::setread() {
  //
      mode = 1;
      readbutton->value(1);
      writebutton->value(0);
      clearbutton->value(0);
      swapbutton->value(0);
      renamebutton->value(0);
}

void BankUI::setrootread() {
  //
      r_mode = 1;
      rootreadbutton->value(1);
      rootwritebutton->value(0);
      rootimportbutton->value(0);
      rootexportbutton->value(0);
      rootclearbutton->value(0);
      rootswapbutton->value(0);
      rootrenamebutton->value(0);
}

void BankUI::refreshmainwindow() {
  //
      int bk = fetchData(0, BANK::control::selectBank, TOPLEVEL::section::bank);
      int rt = fetchData(0, BANK::control::selectRoot, TOPLEVEL::section::bank);
  
      instrumentuiwindow->copy_label(bank->getBankFileTitle(rt, bk).c_str());
  
      bankuiwindow->copy_label(bank->getRootFileTitle(rt).c_str());
  
      for (int i = 0; i < BANK_SIZE; ++i)
          bs[i]->refresh(bk, rt);
      for (int i = 0; i < ROOT_SIZE; ++i)
          rs[i]->rootrefresh();
}

void BankUI::refreshbankslot(int ins, int bk, int rt) {
  //
          bs[ins]->refresh(bk, rt);
}

void BankUI::removeselection() {
  //
          if (nselected >= 0)
          {
              int ns = nselected;
              nselected = -1;
              bs[ns]->refresh(fetchData(0, BANK::control::selectBank, TOPLEVEL::section::bank), fetchData(0, BANK::control::selectRoot, TOPLEVEL::section::bank));
          }
          if (rselected >= 0)
          {
              int rsel = rselected;
              rselected = -1;
              rs[rsel]->rootrefresh();
          }
}

void BankUI::rescan_for_banks(bool reload) {
  //
      banklist->clear();
      if(reload)
      {
          bank->rescanforbanks();
      }
      const BankEntryMap &banks = bank->getBanks(fetchData(0, BANK::control::selectRoot, TOPLEVEL::section::bank));
      BankEntryMap::const_iterator it;
      for (it = banks.begin(); it != banks.end(); ++it)
      {
          if (!it->second.dirname.empty())
          {
              int n = banklist->add((asString(it->first) + ". " + it->second.dirname).c_str(), (const char *)0, (Fl_Callback*)0, reinterpret_cast<void *>(it->first));
              if(it->first == fetchData(0, BANK::control::selectBank, TOPLEVEL::section::bank))
              {
                  banklist->value(n); // ensure correct bank in list
              }
          }
      }
      refreshmainwindow();
}

void BankUI::set_bank_slot() {
  //
      size_t curID = fetchData(0, BANK::control::selectBank, TOPLEVEL::section::bank);
      const Fl_Menu_Item *curItem = 0;
      for(int i = 0; i < banklist->size(); i++)
      {
          const Fl_Menu_Item *item = banklist->menu() + i;
          if(item->label())
          {
              if(curID == reinterpret_cast<size_t>(item->user_data()))
              {
                  curItem = item;
              }
          }
      }
      if(curItem)
      {
          banklist->value(curItem);
      }
      else
      {
          banklist->value(0);
      }
}

void BankUI::activatebutton_rootdir(bool active) {
  //
          if (active)
          {
              removerootdirbutton->activate();
              makedefaultrootdirbutton->activate();
              changeIDbutton->activate();
          }
          else
          {
              removerootdirbutton->deactivate();
              makedefaultrootdirbutton->deactivate();
              changeIDbutton->deactivate();
              Pend->hide();
          }
}

void BankUI::readbankcfg() {
  //
      string tmp;
      rootsbrowse->clear();
      const RootEntryMap &roots = synth->getBankRef().getRoots();
      RootEntryMap::const_iterator it;
      for(it = roots.begin(); it != roots.end(); ++it)
      {
          if (!it->second.path.empty())
          {
              tmp = asString(it->first) + ". " + it->second.path;
              if(it->first == fetchData(0, BANK::control::selectRoot, TOPLEVEL::section::bank))
              {
                  tmp += " *";
              }
              rootsbrowse->add(tmp.c_str(), reinterpret_cast<void *>(static_cast<long>(it->first)));
          }
      }
}

int BankUI::recoverID() {
  //
      if (selectedRootID >= 0)
      {
          return selectedRootID;
      }
      return 0;
}
